module Aufgabe47a where

import Turing
import Turing_Test

import Wort
import Random
import List (inits)

pos = do n <- [ 1 .. 5 ]
	 let nullen = take n $ repeat '0'
	 let einsen = take n $ repeat '1'
	 return $ nullen ++ einsen ++ nullen

isok :: String -> Bool
isok w =
    let (d, r) = length w `divMod` 3
	(a, bc) = splitAt d w
	(b, c) = splitAt d bc
    in r == 0 && d > 0
	      && and [ '0' == x | x <- a ++ c ]
	      && and [ '1' == x | x <- b      ]

wrong l = do
    w <- someIO "01" l
    if isok w then wrong l else return w
    
negIO = do
    random <- sequence $ take 10 $ repeat $ do
	 l <- randomRIO (1, 10); wrong l
    let fixed = [ "", "0011100", "0011001", "0001110000" ]
    return $ fixed ++ random


--------------------------------------------------------------------

bewerte student = do
    putStrLn $ unlines
	     [ "Ich bin der automatische Korrektor fr Aufgabe IV.7a."
	     , ""
	     , "Die Sprache { 0^n 1^n 0^n | n >= 0 }"
	     , "soll durch eine Turingmaschine akzeptiert werden"
	     , ""
	     , "Siehe auch http://www.informatik.uni-leipzig.de/~joe/edu/ws00/auspra/autotool/turing.html"
	     , ""
	     ]
    neg <- negIO
    test 5000 pos neg student

