module Bucket where

import Next

import List (inits, tails)
import Monad (guard)


data Bucket = Bucket [ Int ]
     deriving ( Eq, Ord )

instance Show Bucket where
    show (Bucket xs) = concat $ map show $ xs

instance Next Bucket where
    next (Bucket xs) = do
        (pre, this : that : post) <- zip (inits xs) (tails xs)
	guard $ that > 1
	return $ Bucket $ pre ++ [ this + 1, that - 1 ] ++ post

