module Main where

-- (c) joe@informatik.uni-leipzig.de

import Wort
import Next
import qualified System

main :: IO ()
main = do
    argv <- System.getArgs
    if even (length argv)
       then do putStrLn "die Argumentzahl mu ungerade sein"
	       usage
       else if length argv < 3
           then do putStrLn "bentigt wenigstens eine Regel und ein Startwort"
		   usage
	   else do let rs = do k <- [ 0, 2 .. length argv - 2 ]
			       return $ Regel { from = argv !! k
					      , to   = argv !! (k + 1)
					      }
		   let w = Wort { inhalt = last argv, regeln = rs }
		   paint w
		   return ()

usage :: IO ()
usage = putStrLn $ unlines
      [ "erzeugt Spielbaum (DAG) eines Wort-Ersetzungs-Spiels"
      , "Argumente: l_1 r_1 l_2 r_2 .. l_n r_n w"
      , "Beispiel: 01 10 1 2 011"
      , "interpretiert als Regelmenge { l_1 -> r_1, .. } und Startwort w"
      , "Ausgabe: mit GraphViz gerendert in das File `w.png'"
      ]

