module Officer where

import Takebreak
import Wort
import Next

import PN
import Grundy
import Blank

import qualified Set as S
import qualified MultiSet as M


officer :: Int -> TB
officer x = TB { rules = [ S.emptySet, S.mkSet [ 1, 2 ] ]
	       , heaps = M.unit x
	       }

off :: Int -> IO ()
off x = paint ("off" ++ show x) $ officer x

pnoff :: Int -> IO ()
pnoff x = paint ("pnoff" ++ show x) (build (officer x) :: Labelled TB PN )

bloff :: Int -> IO ()
bloff x = paint ("bloff" ++ show x) 
	$ (Blank $ officer x)

groff :: Int -> IO ()
groff x = paint ("groff" ++ show x) (build (officer x) :: Labelled TB Grundy )

grbloff :: Int -> IO ()
grbloff x = paint ("grbloff" ++ show x) 
	  $ (build (Blank $ officer x) :: Labelled (Blank TB) Grundy )

pnbloff :: Int -> IO ()
pnbloff x = paint ("pnbloff" ++ show x) 
	  $ (build (Blank $ officer x) :: Labelled (Blank TB) PN )

----------------------------------------------------------------------------

wofficer :: Int -> Wort Char
wofficer x = Wort { inhalt = replicate x '1'
	      , regeln = [ Regel { from = "11", to = "10" }
			 ]
	      }

woff :: Int -> IO ()
woff x = paint ("woff" ++ show x) 
       $ wofficer x


pnwoff :: Int -> IO ()
pnwoff x = paint ("pnwoff" ++ show x) 
	$ (build (wofficer x) :: Labelled (Wort Char) PN )



