-- $Id: Lock.hs,v 1.1.1.1 2002/05/24 10:46:45 challenger Exp $

module Lock

-- Hier steht Zeug, das "schon in der ersten Vorlesung zum Thema
-- concurrent programming als streng verboten deklariert wird." Macht
-- aber nichts, wir brauchen nur einen klitzekleinen Mechanismus, der
-- ungefhr die doppelten Anfragen raussammelt. Im schlimmsten Fall
-- laufen dann doch mehrere Instanzen, aber der sollte so oft nicht
-- auftreten...

-- Zum Abgucken ist das also nicht geeignet.

-- Ein Slot ist einfach nur ein String und da Directories auch nur
-- Files sind, nehmen wir die gleich. Es kann beliebig oft
-- (un-)ge"lockt" werden, im Konflikt-Fall gibt es Messages im
-- Logfile.

( is_slot_free   -- :: Settings -> Slot -> IO Bool
, lock_slot      -- :: Settings -> Slot -> IO ()
, unlock_slot    -- :: Settings -> Slot -> IO ()
)

where

-- $Log: Lock.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:45  challenger
-- start
--
-- Revision 1.1  2002/01/18 13:41:31  mrahn
-- - ultrasimples per-User-Slot-Locking eingebaut
--

import Settings
import Note

import Directory
import IO

type Slot = String

is_slot_free :: Settings -> Slot -> IO Bool
is_slot_free set slot = do
			de <- doesDirectoryExist $ (lockdir set) ++ slot
			return $ not de

lock_slot :: Settings -> Slot -> IO ()
lock_slot set slot = do_lock set slot createDirectory "locking"

unlock_slot :: Settings -> Slot -> IO ()
unlock_slot set slot = do_lock set slot removeDirectory "unlocking"

do_lock :: Settings 
	   -> Slot
	   -> ( FilePath -> IO () )
	   -> String
           -> IO ()
do_lock set slot fun msg = 
    catch (fun $ (lockdir set) ++ slot) (upps set slot msg)

upps :: Settings -> Slot -> String -> IOError -> IO ()
upps set slot msg ioe = note set ("error during " ++ msg ++ ", slot: " ++ slot)
