-- $Id: Run.hs,v 1.1.1.1 2002/05/24 10:46:45 challenger Exp $

module Run where

-- inzwischen ist das ziemlich lnglich geworden, u.U. muss da mal mit
-- der Axt dazwischen gegangen werden

-- mostly das alte Autotool_Main, settings stehen in set

-- ausgabe: keine
-- aktionen:
-- 1) dispatcher-file lesen, gltiges subject feststellen, Pfad setzen
-- 2) studenten-file lesen, gltigen Absender feststellen 
-- 2a) falls nicht beides gltig, dann in crap/ schreiben, fertig

-- 3) simulator laufen lassen
-- 4) logfile schreiben, mail an absender schicken
-- 5) files nach  done/  schreiben
-- 6-...) viele viele andere Test und mgliche Verzweigungen...

-- $Log: Run.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:45  challenger
-- start
--
-- Revision 1.11  2002/01/18 13:59:42  mrahn
-- - cosmetics
--
-- Revision 1.9  2002/01/18 13:41:31  mrahn
-- - ultrasimples per-User-Slot-Locking eingebaut
--
-- Revision 1.8  2001/12/11 16:39:52  mrahn
-- matrikelnummer als seed fr pseudozufall
--
-- Revision 1.7  2001/12/03 09:19:18  mrahn
-- - work aufrumen
-- - umlaute aus fa/Properties raus
--
-- Revision 1.6  2001/12/02 18:55:36  mrahn
-- pfade zum grader richtig
--
-- Revision 1.5  2001/12/02 18:37:37  mrahn
-- - verbesserungen an vorkompilierten gradern
-- - alle aufgaben aus ws01 mit vorkompilierten gradern umgesetzt
--
-- Revision 1.4  2001/12/01 14:56:59  autotool
-- memorybeschrnkung
--
-- Revision 1.3  2001/12/01 14:47:33  autotool
-- prekompilierte grader
--
-- Revision 1.2  2001/12/01 11:50:27  mrahn
-- vorkompilierte Korrekturprogramme
--
-- Revision 1.1  2001/11/22 10:41:16  mrahn
-- - Kommandozeile verarbeiten
--

import qualified Settings as S
import qualified Note as N

import Util
import Lock

import FiniteMap
import System
import Posix
import Directory

import Monad ( when )
import List ( tails, partition )

import IO

import Time

-------------------------------------------------------------------------------
-- mainly das alte main

data Modus = Hugs 
	   | GHC 
	   | PreCompiled String

run :: S.Settings -> IO ()
run set = do

   time_total_start <- getClockTime

   id <- getProcessID
   time <- zeit

   contents <- getContents -- from stdin

   let note = N.note set
       crap = N.crap set args contents

       sender = S.sender set
       exercise = S.exercise set

       args = [ sender, exercise ]

       info s = s ++ ": " ++ show args

       cmd_start s = "starte: " ++ s
       cmd_end s = "durchgelaufen: " ++ s

       this = "Run"
       start = info $ cmd_start this
       end = info $ cmd_end this

       sender_unknown = info "Autotool: den absender kenne ich nicht"
       exercise_unknown = info "Autotool: das subject kenne ich nicht"

       slot_not_free slot = info $ "Autotool: slot " ++ slot ++ " not free"
       slot_locked slot = info $ "Autotool: slot " ++ slot ++ " locked"
       slot_unlocked slot = info $ "Autotool: slot " ++ slot ++ " unlocked"

       sender_accepted = info "absender der mail akzeptiert"
       exercise_accepted = info "subject der mail akzeptiert"

       create_dir dir = "erzeuge Verzeichnis " ++ dir
       file_written file = "file " ++ file ++ " geschrieben"
       file_doesnt_exist file = "file " ++ file ++ " fehlt"

       hs_ext = ".hs"
       out_ext = ".out"
       ghc_ext = ".ghc"
       show_ext = ".hs"
       res_ext = ".res"

       stud = "Student" ++ show id 
       mai = "Main" ++ show id 
       sho = "Showed" ++ show id 

       ghc_filter = "Skipping|chasing|Compiling|linking"
       running_time = "Laufzeit"
       output_size = "Grsse der Ausgabe"

       workingdir = S.workdir set ++ show id ++ "/"

       studfile = workingdir ++ stud ++ hs_ext
       mainfile = workingdir ++ mai ++ hs_ext
       showfile = workingdir ++ sho ++ show_ext
       resfile = showfile ++ res_ext
       runfile  = workingdir ++ mai
       outfile = workingdir ++ stud ++ out_ext
       ghc_out = outfile ++ ghc_ext

       studfile_written = file_written studfile
       mainfile_written = file_written mainfile

       showfile_doesnt_exist = file_doesnt_exist showfile 
       resfile_doesnt_exist = file_doesnt_exist resfile 


   note start

   dispatch <- read_dispatch_file set
   path_and_opts <- case lookupFM dispatch exercise of
		    Nothing -> crap exercise_unknown
		    Just p -> return p
   note exercise_accepted

   -- opts wird von derzeitigen dispatch noch nicht benutzt 
   let (opts, path) = partition ( \ x -> head x == '-' ) path_and_opts
       
       modus = case head path of
                "hugs" -> Hugs
                "ghc"  -> GHC
                prog   -> PreCompiled prog

   users <- read_user_files set
   mat <- case lookupFM users sender of
	  Nothing -> crap sender_unknown
	  Just m -> return m
   note sender_accepted

   let verbose_system cmd = do
                            note $ cmd_start cmd
                            system cmd
                            note $ cmd_end $ (head $ words cmd) ++ "..."

   let send_msg_from_file msg_file = do
       let mail_command = unwords 
			  [ "cat" , msg_file ++ " " ++ S.signature_file set
                          , "|", S.rmail set, "-s \"Re: "
                          , exercise ++ "\"", sender 
                          ]
       verbose_system mail_command

   slot_is_free <- is_slot_free set mat

   case slot_is_free of
     False -> do
	      note $ slot_not_free mat
	      send_msg_from_file $ S.slot_not_free_message_file set
	      crap $ slot_not_free mat
     True -> lock_slot set mat

   note $ slot_locked mat

   let msg = time ++ " ( " ++ show id ++ " ) " ++ sender
	     ++ " ( " ++ mat ++ " ) " ++ exercise ++ " : " 

       log_result = "appendFile \"" ++ S.resultfile set
		    ++ "\" $ \"" ++ msg ++ "\" ++ res ++ \"\\n\""

       path_expression = case modus of
            GHC -> unwords opts
		   ++ " -i" ++ workingdir 
		   ++ do p <- tail path; " -i" ++ S.sourcedir set ++ p
            _   -> unwords opts
		   ++ "-P" ++ do p <- tail path; S.sourcedir set ++ p ++ ":"

       run_command = case modus of
	    -- hier gibt es Probleme mit gleichzeitigen Zugriffen, funktioniert
	    -- im Moment nur unter der Annahme, dass die nicht stattfinden...
	    -- => concurrent version => Server!!
            GHC -> unwords 
                   [ S.ghc set, path_expression, mainfile
                   , " -o ", runfile, "2>", ghc_out
		   , "; ", runfile, ">", outfile, "2>&1 ;"
		   , " egrep -v \"" ++ ghc_filter ++ "\" "
                   , ghc_out, ">>", outfile
                   ]
            _  -> unwords 
		  [ S.runhugs set, path_expression
		  , mainfile, ">>", outfile, "2>&1" 
		  ]

   note $ create_dir workingdir
   system $ "mkdir " ++ workingdir

   writeFile studfile 
	     $ unlines 
	     $ ( "module " ++ stud ++ " (student) where" )
	     : takeWhile (/="--") (lines contents)
   note studfile_written

   harmlos set (lines contents)

   let normal_mainfile = unlines
			 [ "module Main (main) where"
			 , "import " ++ exercise ++ " (bewerte)"
			 , "import " ++ stud ++ " (student)"
			 , "main = do"
			 , "  res <- bewerte " ++ show mat ++ " student"
			 , "  " ++ log_result
			 ]

   let show_mainfile = unlines
		       [ "module Main (main) where"

		       , "import " ++ stud ++ " (student)"
		       , "import System"

                       , "test (s,[])     = ' ' : s " -- not too long
		       , "test (s,(x:xs)) = [] "

		       , "main = do"
                       , " let showed = test $ splitAt " 
			 ++ show (S.max_length_of_showed_input set)
		         ++ " $ show student"

		       , " case showed of"
                       , "  [] -> do "
                       , "        msg <- readFile \"" 
		                         ++ (S.input_to_large_message_file set)
                                         ++ "\""
                       , "        putStrLn msg"  
		       , "  _  -> writeFile \"" ++ showfile ++ "\" showed"
		       ]

   let contents_mainfile = case modus of
                            PreCompiled p -> show_mainfile
			    _             -> normal_mainfile

   writeFile mainfile contents_mainfile
   note mainfile_written

   time_start <- getClockTime

   verbose_system run_command

   time_end <- case modus of

     PreCompiled preCompiledGrader  -> do
       showfile_exist <- doesFileExist showfile

       case showfile_exist of
         False -> note showfile_doesnt_exist
         True -> do
           verbose_system $ unwords
	                  [ S.sourcedir set ++ preCompiledGrader
			  , showfile, mat
			  , "+RTS -M" ++ (S.max_mem_for_grader set)
			  , ">>", outfile, "2>&1" 
			  ]

           resfile_exist <- doesFileExist resfile
           case resfile_exist of
             False -> note resfile_doesnt_exist
             True -> do
               res <- readFile resfile
               appendFile (S.resultfile set) (msg ++ " " ++ res)

       getClockTime  

     _ -> getClockTime
					
   let timing ta tb = (show $ tdSec $ diffClockTimes ta tb) ++ " sec"

   h <- openFile outfile ReadMode
   out_size <- hFileSize h
   hClose h

   note $ running_time ++ " " ++ timing time_end time_start ++ ", " 
	  ++ output_size ++ ": " ++ show out_size ++ " bytes"

   let sendfile = case out_size < S.max_mail_size set of
                    True -> outfile
                    False -> S.mail_to_large_message_file set

   send_msg_from_file sendfile

   verbose_system 
    $ unwords [ "  cp " ++ studfile ++ " " ++ S.donedir set
              , "; cat " ++ workingdir ++ stud ++ out_ext
                ++ " | head -c " ++ show (S.max_mail_size set)++ " > " 
                ++ S.donedir set ++ stud ++ out_ext
              , "; rm -f " ++ workingdir ++ "*"
	      , "; rmdir " ++ workingdir
	      ]

   unlock_slot set mat
   note $ slot_unlocked mat

   time_now <- getClockTime

   note $ end ++ ", " ++ timing time_now time_total_start ++ "."


-------------------------------------------------------------------------------
-- file operations

read_dispatch_file :: S.Settings -> IO (FiniteMap String [String])
read_dispatch_file set = do
    let fname = S.dispatch_file set
        make line = do
	       sub : path_and_opts <- return $ words $ takeWhile (/= '#') line
	       return (sub, path_and_opts)

    fm <- readFileToFM set make "dispatch" fname
    return fm


read_user_files :: S.Settings -> IO (FiniteMap String String)
read_user_files set = do
    let fnames = S.user_files set
        make line = do
		    [ mat, vor, nach, mail, grp ] <- return $ words line
		    return ( mail, mat )

    fms <- sequence $ do fname <- fnames
			 return $ do fm <- readFileToFM set make "user" fname
				     return fm
    return $ foldr ( plusFM_C (error "read_user_files") ) emptyFM fms


readFileToFM :: (Ord key) 
		=> S.Settings
		-> (String -> [(key,elt)]) 
		-> String -> String
		-> IO (FiniteMap key elt)
readFileToFM set make info fname = do
  let note = N.note set
  note $ "reading " ++ info ++ " file " ++ fname
  stream <- readFile fname
  note $ "done reading " ++ info ++ " file " ++ fname
  return $ listToFM $ do
		      line <- lines stream
                      res <- make line
		      return res

-------------------------------------------------------------------------------

harmlos :: S.Settings -> [ String ] -> IO ()
harmlos set = sequence_ . map (harm set)

harm :: S.Settings -> String -> IO ()
harm set line = sequence_ $ do 
       w <- tails line
       v <- S.verboten set
       return $ if v == take (length v) w
	  then N.err set $ "verbotenes Wort `" ++ v 
			    ++ "' in Zeile `" ++ line ++ "'"
	  else return ()
