-- $Id: Settings_Make.hs,v 1.1.1.1 2002/05/24 10:46:45 challenger Exp $

module Settings_Make where

-- $Log: Settings_Make.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:45  challenger
-- start
--
-- Revision 1.3  2002/01/18 13:41:31  mrahn
-- - ultrasimples per-User-Slot-Locking eingebaut
--
-- Revision 1.2  2001/12/02 18:37:37  mrahn
-- - verbesserungen an vorkompilierten gradern
-- - alle aufgaben aus ws01 mit vorkompilierten gradern umgesetzt
--
-- Revision 1.1  2001/11/22 10:41:16  mrahn
-- - Kommandozeile verarbeiten
--

import Settings_Type
import Options
import Defaults

-- make Settings from Flags and Dirs and adjust where neccessary
-- the first definition or the default is used
-- user_files and verboten adding defaults to all found values

mkSettings :: [Flag] -> [String] -> Settings
mkSettings flags rest = adjust Settings 
 { sender    = head rest
 , exercise = head $ drop 1 $ rest

 , sourcedir = def [ d | Sourcedir d <- flags ] $ sourcedir dfs

 , workdir   = def [ d | Workdir   d <- flags ] $ workdir dfs
 , donedir   = def [ d | Donedir   d <- flags ] $ donedir dfs
 , bindir    = def [ d | Bindir    d <- flags ] $ bindir dfs
 , configdir = def [ d | Configdir d <- flags ] $ configdir dfs
 , logdir    = def [ d | Logdir    d <- flags ] $ logdir dfs
 , crapdir   = def [ d | Crapdir   d <- flags ] $ crapdir dfs
 , queuedir  = def [ d | Queuedir  d <- flags ] $ queuedir dfs
 , lockdir   = def [ d | Lockdir   d <- flags ] $ lockdir dfs
 
 , logfile    = def [ f | Logfile    f <- flags ] $ logfile dfs
 , resultfile = def [ f | Resultfile f <- flags ] $ resultfile dfs
 , crapfile   = def [ f | Crapfile   f <- flags ] $ crapfile dfs

 , crapfile_ext = def [ e | Crapfile_ext e <- flags ] $ crapfile_ext dfs
 
 , dispatch_file  = def [ f | Dispatch_file  f <- flags ] $ dispatch_file dfs
 , user_files     =     [ f | User_files     f <- flags ] ++ user_files dfs
 , signature_file = def [ f | Signature_file f <- flags ] $ signature_file dfs

 , verboten       = [ v | Verboten v <- flags ] ++ verboten dfs

 , max_mail_size  = def [ i | Max_mail_size i <- flags ] $ max_mail_size dfs
 , mail_to_large_message_file 
     = def [ f | Mail_to_large_message_file f <- flags ] 
       $ mail_to_large_message_file dfs

 , max_length_of_showed_input  
     = def [ i | Max_length_of_showed_input i <- flags ] 
       $ max_length_of_showed_input dfs
 , input_to_large_message_file 
     = def [ f | Input_to_large_message_file f <- flags ]
       $ input_to_large_message_file dfs

 , slot_not_free_message_file 
     = def [ f | Slot_not_free_message_file f <- flags ]
       $ slot_not_free_message_file dfs

 , max_mem_for_grader = def [ s | Max_mem_for_grader s <- flags ] 
			$ max_mem_for_grader dfs

 , runhugs = def [ c | Runhugs c <- flags ] $ runhugs dfs
 , ghc     = def [ c | Ghc     c <- flags ] $ ghc dfs
 , rmail   = def [ c | Rmail   c <- flags ] $ rmail dfs
 } 
 where def xs d = head $ xs ++ [d]
       dfs = default_settings





