-- $Id: Settings_Type.hs,v 1.1.1.1 2002/05/24 10:46:45 challenger Exp $

module Settings_Type where

-- $Log: Settings_Type.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:45  challenger
-- start
--
-- Revision 1.3  2002/01/18 13:41:31  mrahn
-- - ultrasimples per-User-Slot-Locking eingebaut
--
-- Revision 1.2  2001/12/02 18:37:37  mrahn
-- - verbesserungen an vorkompilierten gradern
-- - alle aufgaben aus ws01 mit vorkompilierten gradern umgesetzt
--
-- Revision 1.1  2001/11/22 10:41:16  mrahn
-- - Kommandozeile verarbeiten
--

data Settings = Settings 
	      { sender   :: String
              , exercise :: String

	      , sourcedir :: String

	      , workdir   :: String
	      , donedir   :: String
	      , bindir    :: String
	      , configdir :: String
	      , logdir    :: String
	      , crapdir   :: String
	      , queuedir  :: String
	      , lockdir   :: String

	      , logfile    :: String
	      , resultfile :: String
	      , crapfile   :: String

              , crapfile_ext :: String 

	      , dispatch_file  :: String
	      , user_files     :: [ String ]
	      , signature_file :: String

	      , verboten :: [ String ]

	      , max_mail_size              :: Integer
	      , mail_to_large_message_file :: String

	      , max_length_of_showed_input  :: Integer
	      , input_to_large_message_file :: String

	      , slot_not_free_message_file :: String

              , max_mem_for_grader :: String

	      , runhugs :: String
	      , ghc     :: String
	      , rmail   :: String
	      }

-- constraints
-- - files and paths are absolut or will made absolut w.r.t. sourcedir

adjust :: Settings -> Settings
adjust s = Settings
 { sender   = sender s
 , exercise = exercise s

 , sourcedir = sourcedir'

 , workdir   = mkaSource $ workdir s
 , donedir   = mkaSource $ donedir s
 , bindir    = mkaSource $ bindir s
 , configdir = configdir'
 , logdir    = logdir'
 , crapdir   = crapdir'
 , queuedir  = mkaSource $ queuedir s
 , lockdir   = mkaSource $ lockdir s

 , logfile    = mka logdir' $ logfile s
 , resultfile = mka logdir' $ resultfile s
 , crapfile   = mka crapdir' $ crapfile s

 , crapfile_ext   = crapfile_ext s

 , dispatch_file  = mka configdir' $ dispatch_file s
 , user_files     = map (mka configdir') $ user_files s
 , signature_file = mka configdir' $ signature_file s

 , verboten       = verboten s

 , max_mail_size               = max_mail_size s
 , mail_to_large_message_file  = mka configdir' $ mail_to_large_message_file s

 , max_length_of_showed_input  = max_length_of_showed_input s
 , input_to_large_message_file = mka configdir' $ input_to_large_message_file s

 , slot_not_free_message_file  = mka configdir' $ slot_not_free_message_file s

 , max_mem_for_grader = max_mem_for_grader s

 , runhugs = runhugs s
 , ghc     = ghc s
 , rmail   = rmail s
 }
 where sourcedir' = mkDir $ sourcedir s

       configdir' = mkaSource $ configdir s
       logdir'    = mkaSource $ logdir s
       crapdir'   = mkaSource $ crapdir s

       mkaSource  = mkDir . mka sourcedir'

       mka root dir  = case is_absolut dir of
	 	        True  -> dir
		        False -> root ++ dir

       is_absolut [] = False
       is_absolut xs = (=='/') $ head xs

       mkDir [] = "/"
       mkDir s  = case last s of
                   '/' -> s
                   _   -> s ++ "/"
