module PCP.Applet where

import Component
import IOExts

type PCP = [ (String, String) ]


kname :: Int -> Ident
kname k = Ident $ "P" ++ show k

applet :: PCP -> IO Pool
applet pcp = do

    let topword m = do x <- m; fst (pcp !! (x-1))
    let botword m = do x <- m; snd (pcp !! (x-1))

    let isprefix xs ys = xs == take (length xs) ys

    midR <- newIORef [] -- lsungswort (eingabe)

    let top = Component { kind = Label, ident = Ident "Top"
			, options = [ Position (50, 10), Text "leer" ]
			, action = const $ return no_update
			} 
    let mid = Component { kind = Label, ident = Ident "Mid"
			, options = [ Position (70, 10), Text "leer" ]
			, action = const $ return no_update
			} 
    let bot = Component { kind = Label, ident = Ident "Bot"
			, options = [ Position (90, 10), Text "leer" ]
			, action = const $ return no_update
			} 

    let set m = do
	  let t = topword m
	  let b = botword m
          writeIORef midR m
	  return $ Update { new = [], delete = [] 
	         , change = [ top `with_options` [ Text        t ]
			    , mid `with_options` [ Text $ show m ]
			    , bot `with_options` [ Text        b ]
			    ]
		 }
	  

    let new = Component { kind = Button , ident = Ident "New"
		     , options = [ Text "New", Position (10,10) ]
		     , action = \ click -> set []
		     }
    let undo =  Component { kind = Button , ident = Ident "Undo"
		     , options = [ Text "Undo", Position (10,50) ]
		     , action = \ click -> do
		         m <- readIORef midR
			 if null m then return no_update
				   else set (init m)
		     }
    let extend k = do
	   m <- readIORef midR
	   let mk = m ++ [k]
	   let (t, b) = (topword mk, botword mk)
	   if isprefix t b || isprefix b t
	      then set mk else return no_update

    let pairs = do
           (k, (l,r)) <- zip [1..] pcp
	   return $ Component { kind = Button, ident = kname k
			      , options = [ Text ( l ++ "/" ++ r )
					  , Position (30, k*50)
					  ]
			      , action = \ click -> extend k
			      }

    
    make $ [ new, undo ] ++ pairs ++ [ top, mid, bot ]








