module Server.Central where

import Component
import Expression

import qualified Socket as S

import qualified IO
import qualified Concurrent

import Posix



data Par = Par { socket :: S.Socket
	       , pool :: Pool
	       , handle :: IO.Handle 
	       }

server :: Int -> Pool -> IO ()
server portnum p = do

    Posix.installHandler Posix.sigPIPE Posix.Ignore Nothing

    logger $ "mappe einrichten"

    logger $ "port einrichten"
    let port = S.PortNumber $ fromIntegral portnum
    s <- S.listenOn port
    
    logger $ "Server starten"
    receptions $ Par { socket = s, pool = p }


-- mehrere clienten behandeln
receptions :: Par -> IO ()
receptions p = sequence_ $ repeat $ do
    reception p 
        `catch` \ any -> do
            logger  $ "ignoriere Fehler in Steward.reception"

-- einen clienten behandeln
reception :: Par -> IO ()
reception p = do
    (h, rhost, rport) <- S.accept (socket p)
    let id = show (rhost, rport)
    logger $ "accecping connection from " ++ show id
    Concurrent.forkIO $ handler $ p { handle = h } 
    return ()

-- folge von anfragen eines clienten bearbeiten
handler :: Par -> IO ()
handler p = do
    input <- IO.hGetLine (handle p); IO.hFlush (handle p)

    logger $ "raw input: " ++ input
    logger $ "input length: " ++ show (length input)

    if null input
       then handler p
       else do

	    let q = read input :: Expression
	    logger $ "parsed input: " ++ show q

	    a <- answer (pool p) q
	    let output = show a
    
	    logger $ "raw output: " ++ output
	    IO.hPutStrLn (handle p) output; IO.hFlush (handle p)

	    if a == logout then do IO.hClose (handle p); return ()
		   else handler p -- weitermachen
    
    
logger :: String -> IO ()
logger msg = IO.hPutStrLn IO.stderr $ msg



