

import cnctParser.*;
import java.lang.reflect.*;


public class ComponentLoader
{
	private parser myParser;
	
	public ComponentLoader ()
	{
		myParser = new parser();
	}
	
	public MyComponent loadClass (String classString)
	{
		knoten tree;
		MyComponent result;
		
		
		myParser.baueBaum (classString);
		tree = myParser.getSyntaxBaum ();
		
		try
		{
			//nach der gewnschten Klasse suchen...
			Class newClass = Class.forName ("My"+tree.getName());
				//System.out.println ("Classname: "+tree.getName());

			//eine Stufe im Baum tiefer gehen
			tree = tree.getKind(0);
			
			/*
			
			//Anzahl der Argumente fr den Konstruktor feststellen
			int anzahl = tree.getKinderZahl();
				//System.out.println ("Kinderzahl: "+anzahl);
			
			//entsprechend viele Argumente sollen erzeugt werden
			Class argsType[] = new Class[anzahl];
			Object args[] = new Object[anzahl];
			
			//Typ der Argumente feststellen
			for (int i=0; i<anzahl; i++)
			{
				knoten subtree = tree.getKind(i).getKind(0);
				int typ = subtree.getTyp();
					//System.out.println ("Typ "+subtree.getTyp());
				
				//Signatur des Konstruktors und Argumentliste erstellen
				switch (typ)
				{
					case tree.STRING:	argsType[i] = java.lang.String.class;
										args[i] = new String(subtree.getName());
										break;
					case tree.ZAHL:		argsType[i] = int.class;
										args[i] = new Integer(subtree.getZahl());
										break;
			
				}
			}
			*/
			
			
			//nach einem entsprechenden Konstruktor suchen
			//Constructor cons = newClass.getConstructor(argsType);
			Class argsType[] = new Class[] {cnctParser.knoten.class};
			Object args[] = new Object[] {tree};
			Constructor cons = newClass.getConstructor(argsType);
			
			//mittels des gefundenen Konstruktors eine Instanz erzeugen
			result = (MyComponent)cons.newInstance (args);
			
			return result;
		}
		catch (ClassNotFoundException e)
		{
			System.out.println ("Klasse konnte nicht geladen werden!");
			System.out.println (e);
		}
		catch (NoSuchMethodException e)
		{
			System.out.println ("Klassenkontruktor nicht gefunden!");
			System.out.println (e);
		}
		catch (InstantiationException e)
		{
			System.out.println ("Klasseninstanz konnte nicht gebildet werden!");
			System.out.println (e);
		}
		catch (IllegalAccessException e)
		{
			System.out.println ("Verletzung der Zugriffsrechte!");
			System.out.println (e);
		}
		catch (InvocationTargetException e)
		{
			System.out.println ("Exception...");
			System.out.println (e);
		}
		catch (IllegalArgumentException e)
		{
			System.out.println ("Argumente stimmen nicht!");
			System.out.println (e);
		}

		
			
		return null;
	}
}
