// FILE: Loader.java

import cnctParser.*;


public class Manager implements Runnable
{
	private ServerInterpreter server;

	private Viewer myViewer;
	private ControlPanel myController;
	private Queue compQueue;
	
	
	private Thread runner;
	private boolean isRunning;
	private String message;	
	
	
	public Manager()
	{
		server = new ServerInterpreter();
		compQueue = new Queue();
		
		myViewer = new Viewer (this);
		myController = new ControlPanel (this);
		
		isRunning = false;
		
		server.openConnection ();
	}
	
	public void run()
	{
		isRunning = true;
		
		String command = server.getCommand (message);
		command = new String ("Update");


		if (command.equals ("Update"))		
		{
			MyComponent newComps[], changedComps[], deletedComps[];
		
			newComps 		= server.getNew ();
			changedComps 	= server.getChanged ();
			deletedComps 	= server.getDeleted ();
			
		//--------------------------------------
		//Komponenten in Queue updaten!!
			
			//zuerst alle neuen hinzufgen
			for (int i=0; i<newComps.length; i++)
			{
				if ( newComps[i] != null)
				{
					myViewer.addToViewer (newComps[i]);
				}
			}
			
			//danach alle changed
			for (int i=0; i<changedComps.length; i++)
			{
				if ( changedComps[i] != null)
				{
					myViewer.addToViewer (changedComps[i]);
				}
			}
			
			//und die deleted
			for (int i=0; i<deletedComps.length; i++)
			{
				if ( deletedComps[i] != null)
				{
					myViewer.removeFromViewer (deletedComps[i]);
				}
			}

		//Queue
		//--------------------------------------
		}
		/* fr andere Commands...
		
		else if (action.equals (""))
		{
		}
		
		*/
		
		isRunning = false;
	}	
	
	public void sendMessage (String msg)
	{
		if (!isRunning)
		{
			message = msg;
			runner = new Thread (this);
			runner.start ();
		}
	}

	public void loadExercise()
	{
		//vorlufig...
		sendMessage ("Hello");
	}

	public void exitProgram()
	{
		server.closeConnection();
		System.exit(0);
	}

	public Viewer getViewer ()
	{
		return myViewer;
	}

	public ControlPanel getController ()
	{
		return myController;
	}

	public Queue getQueue ()
	{
		return compQueue;
	}
} 
