// FILE: MyComponent.java


import java.awt.*;
import cnctParser.*;


public abstract class MyComponent
{
	public String ident;
	private knoten tree;
	protected Parameter paramList[];
	
	public void getParameter (knoten t)
	{
		tree = t;

		//Anzahl der Argumente feststellen
		int anzahl = tree.getKinderZahl();
			//System.out.println ("Kinderzahl: "+anzahl);
		
		//entsprechend viele Argumente sollen erzeugt werden
		paramList = new Parameter[anzahl];

		//Typ und Namen der Argumente feststellen
		for (int i=0; i<anzahl; i++)
		{
			String name;
			Object value = null;
			
			knoten subtree = tree.getKind(i);
			name = subtree.getName();
				//System.out.println(name);
			
			subtree = subtree.getKind (0);
			int typ = subtree.getTyp ();
				//System.out.println ("Typ "+subtree.getTyp());
			
			//Signatur des Konstruktors und Argumentliste erstellen
			switch (typ)
			{
				case tree.STRING:	value = (Object)(subtree.getName());
									break;
				case tree.ZAHL:		value = (Object)(new Integer(subtree.getZahl()));
									break;
				case tree.TUPEL :	if (name.equals("position"))
									{
										int x = subtree.getKind(0).getZahl();
										int y = subtree.getKind(1).getZahl();
										Point p = new Point (x, y);
										value = (Object)(p);
									}
		
			}
			paramList[i] = new Parameter (name, value);
		}
				
	}
	
	public abstract void draw(Graphics g);
	
	public String getIdent()
	{
		return ident;
	}
}
