import cnctParser.*;

 


public class ServerInterpreter extends Protocol
{
	private ComponentLoader compLoader;
	private parser myParser;
	
	private MyComponent newComps[];
	private MyComponent changedComps[];
	private MyComponent deletedComps[];

	
	

	public ServerInterpreter()
	{
		super();
		
		compLoader = new ComponentLoader ();
		myParser = new parser ();
	}
	
	public String getCommand(String msg)
	{
		String command, answer;
		knoten tree;
		
		sendToServer (msg);
		System.out.println("Client>> "+msg);

		answer = getAnswer();
		//answer = new String("Update {change = [], new = [L2], delete = []}");
		System.out.println("Server>> "+answer);
		
		myParser.baueBaum (answer);
		tree = myParser.getSyntaxBaum ();
		command = tree.getName();
		
		if (command.equals ("Update"))
		{
			createAllComponents (tree.getKind (0));
		}
		else if (command.equals ("Components"))
		{
			String s = new String();
			tree = tree.getKind(0);
			for(int i=0;i<tree.getKinderZahl();i++)
			{
				s = s + tree.getKind(i).getName();
				if(tree.getKind(i+1)!=null) s=s+",";
			}
			String r = new String("Update{change=[],new=["+s+"],delete=[]}");
			myParser.baueBaum (r);
			tree = myParser.getSyntaxBaum ();
			command = tree.getName();
			createAllComponents (tree.getKind	(0));

			//System.out.println(r);
		}
		/* fr andere action-commands...
		else if (command.equals ("..."))
		{
		}
		*/
		
		return command;
	}
	
	private void createAllComponents (knoten tree)
	{
		for (int i = 0; i < tree.getKinderZahl (); i++)
		{
			knoten el = tree.getKind(i);
			
			if (el.getName().equals("change"))
			{
				el = el.getKind(0);
				int anzahl = el.getKinderZahl();
				if ( anzahl > 0) changedComps = new MyComponent[anzahl];
				
				for (int j=0; j<el.getKinderZahl(); j++)
				{
					//ident des Objekts holen
					String name = el.getKind(j).getName();
					if (name != null)
					{
						System.out.println("Client>> Component{ident="+el.getKind(j).getName()+"}");
						sendToServer ("Component{ident="+el.getKind(j).getName()+"}");

						//Antwort vom Server holen ...
						String answer = getAnswer();
						//String answer = new String ("Label {ident=\"L2\", position = (100,100), text=\"Stefan hats endlich!\"}");
						System.out.println ("Server>> "+answer);
						
						//...und Komponente erzeugen
						MyComponent component = compLoader.loadClass(answer);
						changedComps[j] = component;
					}
				}
			}
			else if (el.getName().equals("new"))
			{
				el = el.getKind(0);
				int anzahl = el.getKinderZahl();
				newComps = new MyComponent[anzahl];
				
				for (int j=0; j<anzahl; j++)
				{
					//ident des Objekts holen
					String name = el.getKind(j).getName();
					if (name != null)
					{
						System.out.println("Client>> Component{ident="+el.getKind(j).getName()+"}");
						sendToServer ("Component{ident="+el.getKind(j).getName()+"}\n");
					
						//Antwort vom Server holen ...
						String answer = getAnswer();
						//String answer = new String ("Label {ident=\"L2\", text=\"Stefan hat es!\", position = (20,50) }");
						System.out.println ("Server>> "+answer);

						//...und Komponente erzeugen
						MyComponent component = compLoader.loadClass(answer);
						newComps[j] = component;
					}				
				}

			}
			else if (el.getName().equals("delete"))
			{
				el = el.getKind(0);
				int anzahl = el.getKinderZahl();
				deletedComps = new MyComponent[anzahl];

				for (int j=0; j<el.getKinderZahl(); j++)
				{
					//ident des Objekts holen
					String name = el.getKind(j).getName();
					if (name != null)
					{
						System.out.println("Component{ident="+el.getKind(j).getName()+"}");
						sendToServer ("Component{ident="+el.getKind(j).getName()+"}\n");

						//Antwort vom Server holen ...
						String answer = getAnswer();
						//String answer = new String ("Label {ident=\"L2\", x=20, y=50, text=\"Stefan hats!\"}");
						System.out.println ("Server>> "+answer);

						//...und Komponente erzeugen
						MyComponent component = compLoader.loadClass(answer);
						deletedComps[j] = component;
					}							
				}
			}
		}
	}
	
	public MyComponent[] getNew ()
	{
		return newComps;
	}

	public MyComponent[] getChanged ()
	{
		return changedComps;
	}

	public MyComponent[] getDeleted ()
	{
		return deletedComps;
	}
}
