// FILE: Viewer.java

import java.util.*;
import java.awt.*;
import java.awt.event.*;


 

public class Viewer extends Panel implements MouseListener 
{
	private Graphics myGraphics;	//offscreen-Gertekontext
	private Image offImage;			//offscreen-Image
	private boolean graphCreated;	//true, wenn offscreen-buffer erstellt; false sonst
	
	private Queue compQueue;
	private Manager myManager;
	
	
	
	
	public Viewer(Manager m)
	{
		myManager = m;
		
		compQueue = myManager.getQueue();

		setBackground (new Color (213, 204, 187));
		//System.out.println("Viewer created.");
		graphCreated = false;
		addMouseListener(this);
	}
	
	public void paint(Graphics g)
	{
		if(!graphCreated) getGraphix();
		
		if (offImage != null) 
		{
			g.drawImage(offImage,0,0,null);
			//System.out.println("paint ausgefhrt");
		}
	}
	
	public Graphics getGraphix()
	{
		if (!graphCreated) 
		{
			offImage = createImage(600, 400);
			if(offImage == null) System.out.println("Fehler in Viewer::getGraphix, offImage = null.");
			else myGraphics = offImage.getGraphics();		
			
			graphCreated = true;
		}
	
		return myGraphics;
	}
	
	public void addToViewer (MyComponent comp)
	{
		compQueue.setPosition (0);
		
			
		MyComponent c;
		while ((c = (MyComponent)compQueue.getNext()) != null)
		{
			if (c.ident.equals(comp.ident))
			{
				compQueue.replaceElement (comp);
				updateComponents();
				return;
			}
		}
		
		compQueue.addTail (comp);
		updateComponents();
	}
	
	public void removeFromViewer ( MyComponent comp)
	{
		compQueue.setPosition (0);
	
		
		MyComponent c;
		while ((c = (MyComponent)compQueue.getNext()) != null)
		{
			if (c.ident.equals(comp.ident))
			{
				compQueue.removeFromQueue (c);
				updateComponents();
				return;
			}
		}	
	}
	
	public void updateComponents()
	{
		//if (!graphCreated) getGraphix();
		
		if (myGraphics != null) 
		{
			//Bildschirm lschen
			myGraphics.setColor(getBackground());
			myGraphics.fillRect(0,0,600,400);
		}
		
		compQueue.setPosition (0);
		
		MyComponent c;
		while ((c = (MyComponent)compQueue.getNext()) != null)
		{
			if (myGraphics != null) 
			{
				//Objekte zeichnen
				myGraphics.setColor(Color.black);
				c.draw(myGraphics);
			}
		}
		repaint();
	}
	
	public void mouseClicked (MouseEvent me)
	{
		System.out.println("Client>> Clicked {ident = Viewer}");
	}
	
	public void mousePressed (MouseEvent me)
	{
		//System.out.println("Event in Viewer: Pressed.");
	}
	
	public void mouseReleased (MouseEvent me)
	{
		//System.out.println("Event in Viewer: Released.");
	}
	
	public void mouseEntered (MouseEvent me)
	{
		//System.out.println("Event in Viewer: Entered.");
	}
	
	public void mouseExited (MouseEvent me)
	{
		//System.out.println("Event in Viewer: Exited.");
	}
	

}
