module Datei 
 (  schreiben
  , anhaengen
  , lesen
  , relativieren
  , erzeugeVerzeichnisse
  , Datei (..)
  )
  where


import List (inits, intersperse)
import Directory
import Monad (guard, when)

data Datei = Datei{ pfad :: [String]
                  , name :: String
                  , relativzahl :: Int
                  }

instance Show Datei where
  show d =  concat $ intersperse "/" (pfad d ++ [name d])

anhaengen :: Datei -> String -> IO()
anhaengen d inhalt = do
    createDir d
    appendFile (show d) inhalt

schreiben :: Datei -> String -> IO()
schreiben d inhalt = do
    createDir d
    writeFile (show d) inhalt

lesen :: Datei -> IO(String)
lesen d  = do
    readFile (show d)

relativieren :: Datei -> String
relativieren d = concat $ intersperse "/" ((drop (relativzahl d) (pfad d)) ++ [name d])
    

erzeugeVerzeichnisse :: Datei -> IO ()
erzeugeVerzeichnisse = createDir

createDir :: Datei -> IO ()
createDir d = sequence_ $ do
    prefix <- inits $ pfad d
    guard $ not $ null prefix
    let path = concat $ intersperse "/" prefix
    return $ do ok <- doesDirectoryExist path
                when ( not ok ) $ do 
--                     putStrLn $ "creating directory " ++ show path
                     createDirectory path

