module IsomorphieTest 
    ( isomorphieTest 
    )
    where

import qualified Challenger as C
import qualified Instanzen  as I
import Iso
import Number

-- | prueft die Isomorphie mit den bisherigen Instanzen 
-- (1) Aufgabe
-- return (existiert eine Isomorphie, Nummer, mit der die Instanz uebereinstimmt
isomorphieTest :: (C.Problem p i b, Number i iint, Read iint, Show iint, Iso iint) => C.Einsendung p i b -> IO (Bool,C.Ident)
isomorphieTest (e @ C.Aufgabe {}) = do 
     instList <- I.getAlle (C.problem e)
     let 
        idents = map I.ident $ I.nurKorrekte instList
        norminst = (number (C.instanz e))     
     instanzen <- I.ladeAlleInt (C.problem e) norminst idents
     print instanzen
     return $ testeIsoList norminst instanzen 1

-- | Hilfsfunktion zu IsomorphieTest
-- prueft jetzt direkt die Isomorphie
-- (1) Instanz
-- (2) Liste der Instanzen
-- (3) index (start mit 0)    
-- return wie bei IsomorphieTest
testeIsoList :: (Iso y) => y -> [y] -> Int -> (Bool, C.Ident)
testeIsoList _ [] _ = (False , C.Ident{C.aufgabe=(-1)})
testeIsoList inst (i:instlist) index =
	if (iso i inst) 
  	then (True , C.Ident {C.aufgabe = index}) 
  	else (testeIsoList inst instlist (index+1)) 
