module Main where

import Graph.Graph
import Graph.Util
import Set
import Monad(guard)
import Graph.Vis

--graph1 = Graph { knoten = mkSet [] 
	--	,kanten = mkSet []}

-- main = print graph1 
main = regelanwendung "01001221" regeln 

-- r1 :: String -> String 

data Regel = Regel {
	   from :: String
	 , to :: String
	 }

autofahren :: [String] -> [Regel] -> Graph (String)
autofahren [] reg = Graph { knoten = mkSet [],kanten = mkSet []}
autofahren (s:str) reg = graphToGraph 
	(autofahren ((str) ++ (regelanwendung s reg)) reg )
	(autofahren2 s reg (regelanwendung s reg))

graphToGraph :: Graph(String) -> Graph(String) -> Graph(String)
graphToGraph graph1 graph2 = Graph{
            knoten = mkSet ((knotenliste graph1) ++ (knotenliste graph2)),
 	    kanten = mkSet ((kantenliste graph1) ++ (kantenliste graph2))}


autofahren2 :: String -> [Regel] -> [String] -> Graph(String)
autofahren2 str reg [] = Graph { knoten = mkSet [],kanten = mkSet []}
autofahren2 str reg (c:cx) = addToGraph (autofahren2 str reg cx) str c

addToGraph :: Graph (String) -> String -> String -> Graph (String)
addToGraph graph str x = Graph{knoten = mkSet ((knotenliste graph) ++ [x]),
			kanten = mkSet ((kantenliste graph) ++ [kante str x])}

-- | Regelanwendung:
-- Eingabe x y 
-- mit x = String [ aus nur Null | Eins | Zwei ]
-- und y = Regelmenge
-- Ausgabe = Menge aller aus der Eingabe erzeugbaren Wrter
regelanwendung :: String -> [Regel] -> [String]
regelanwendung str reg = do
	z <- (fakfuncinvers str)
        x <- (fakfunc str)
	y <- reg
	guard ((z ++ x)== str)
	guard (prefix x (from y)) 
	return $ z ++ (to y) ++ (drop (length (from y)) x)
	  --return ("dort") --return (x regelanwendung tail x r)

fakfunc :: String -> [String]
fakfunc [] = [""]
fakfunc str = [str] ++ fakfunc ( tail str ) 

fakfuncinvers :: String -> [String]
fakfuncinvers [] = [""]
fakfuncinvers str =  fakfuncinvers(take(length(str)-1)str) ++ [str]
-- reverse(tail(reverse(str))))

-- | Prfix:
-- Parameter 1 = String
-- Parameter 2 = zu testender Anfangsstring
prefix :: String -> String -> Bool
prefix [] [] = True
prefix [] b = False
prefix a [] = True
prefix (s:str) (p:pre) = case (s==p) of
				True -> prefix str pre
          		        False -> False

regeln = [ Regel { from = "01", to = "10" }
	 , Regel { from = "1" , to  = "2" }
	 ]
