-- | Das ist ein Sammelmodule fuer den Kontrolleur 
--    sammelt alle Problem-imports
--	  wichtig ist auch die Iso instanzierung der verwendeten 
--	  Instanzen einzubinden
--
-- autor Georg Martius
-- mai99dgf@studserv.uni-leipzig.de

module Problems
   ( module Graceful.Graceful
--   , module Col.Col
   , module DreiCol.DreiCol
   , module Hamilton.Hamilton
   , module Clique.Clique
   , module PCProblem.PCProblem
   , module Faktor.Faktor
   , Graph.Type.iso
   , Graph.Type.number
   , PCP.Type.iso   
   , PCP.Type.number 
   , challengerWurzelverz
   , problemListe
   )
   where

-- 
import Sort

import qualified Graph.Type
import qualified PCP.Type
import Konfiguration

import Graceful.Graceful
-- import Col.Col
import DreiCol.DreiCol
import Hamilton.Hamilton
import Clique.Clique
import PCProblem.PCProblem
import Faktor.Faktor


problemListe =  sort 
                [ show Graceful
--		, show Col
		, show DreiCol
                , show Hamilton
                , show Clique                
		, show PCProblem        
		, show Faktor
                ]

