-- | vergleicht zweier graphen auf isomorphie
--
-- autor m.lindemeyer
-- (8484955)

module Graph.Isomorph (isomorphgraph) where 

import Graph.Graph
import Sort
import Set
import Graph.Util

---------------------------------------------------------------------------------------------------
-- | vergleicht zweier graphen auf isomorphie
isomorphgraph :: (Ord a, Eq a) => Graph a -> Graph a -> Bool
isomorphgraph a b = 
  if gradgleich (sort(gradlisteaufruf a)) (sort(gradlisteaufruf b)) 
    then gradgleich (sortordnungsliste a) (sortordnungsliste b)
    else False

-- | staendig auftretende abkuerzungen
gradlisteaufruf :: (Ord a, Eq a) => Graph a -> [Integer]
gradlisteaufruf a = gradliste(kantenliste a)(knotenliste a)
sortordnungsliste :: (Ord a, Eq a) => Graph a -> [Integer]
sortordnungsliste a = sort $ ordnungliste (kantenliste a) (knotenliste a) (gradlisteaufruf a) a

---------------------------------------------
-- | vergleich zweier sortierter (grad)listen
--die anderen faelle werden vernachlaessigt, da in isomoph.hs nur graphen gleicher knotenlaenge gegeben werden.
gradgleich :: [Integer] -> [Integer] -> Bool
gradgleich [][] = True
gradgleich (a:as)(b:bs) = 
  if a==b 
    then gradgleich as bs 
    else False

---------------------------------------------
-- | gradzahlen jeden knotens in eine liste ohne sortierung
gradliste :: (Ord a, Eq a) =>[Kante a] -> [a] -> [Integer]
gradliste a [] = []
gradliste a (b:bs) = [grad a b] ++ gradliste a bs

  
-------------------------------------------------------------------------------------------
-- | ordnung eines knotens ist die summe aller gradzahlen der nachbarknoten
ordnungliste :: (Ord a, Eq a) =>[Kante a] -> [a] -> [Integer] -> Graph a -> [Integer]
ordnungliste lka [] lgrad g= [] 
ordnungliste lka (b:bs) lgrad g= [ordnung lka b lgrad (knotenliste g)] ++ ordnungliste lka bs lgrad g

---------------------------------------------
-- | gradzahl zu einem jeden knoten
ordnung :: (Ord a, Eq a) => [Kante a]-> a -> [Integer] -> [a] -> Integer
ordnung [] kn lgrad lkn = 0
ordnung (a:as) kn lgrad lkn = 
  if kn==von a
    then lgrad!!((zaehleab (nach a) lkn) -1) + ordnung as kn lgrad lkn 
    else
      if kn==nach a
        then lgrad!!((zaehleab (von a) lkn)-1) + ordnung as kn lgrad lkn
        else ordnung as kn lgrad lkn

---------------------------------------------
-- | finde position eines knoten in knotenliste
zaehleab :: (Ord a, Eq a) => a -> [a] -> Int
-- ERROR: zaehleab a [] = 5000000
zaehleab a (b:bx) = 
  if a==b
    then 1
    else 1 + zaehleab a bx

