module Analyze


where

import NFA
import Normalize
import qualified Exp

import Array
import FiniteMap
import Set
import Monad ( guard )

analyze :: Ord s => NFA s -> Exp.Exp
analyze a =
    let b = normalize a
	xs = lstates b
	(lo, hi) = (minimum xs, maximum xs)
	t = array ((lo,lo,lo-1),(hi,hi,hi)) $ do
	    k <- (lo - 1) : xs
	    i <- xs
	    j <- xs
	    return ((i,j,k), tab i j k)
	tab i j k | k < lo = 
	    foldr Exp.union ( if i == j then Exp.Epsilon else Exp.Empty ) $ do
		  ((p, c), qs) <- ltrans b; q <- setToList qs
		  guard  $ p == i && q == j
		  return $ Exp.Letter c
	tab i j k | k >= lo = Exp.union (t ! (i, j, k-1)) $
	    foldr1 Exp.dot [ t ! (i, k, k-1)
		       , Exp.star $ t ! (k, k, k-1)
		       , t ! (k, j, k-1) 
		       ]
    in	foldr Exp.union Exp.Empty $ do
	    i <- lstarts b; j <- lfinals b
	    return $ t ! (i, j, hi)

