module Basic where

import NFA_Type
import Set
import FiniteMap

empty :: NFA Int
empty = NFA { states = mkSet [1]
	    , starts = mkSet [1]
	    , finals = mkSet []
	    , trans = emptyFM
	    }

sigmastar :: String -> NFA Int
sigmastar alpha =
    NFA { states = mkSet [1]
	, starts = mkSet [1]
	, finals = mkSet [1]
	, trans = listToFM $ do
	      c <- alpha
	      return ((1, c), unitSet 1)
	}

sigma :: String -> NFA Int
sigma alpha =
    NFA { states = mkSet [0,1]
	, starts = mkSet [0]
	, finals = mkSet [1]
	, trans = listToFM $ do
	      c <- alpha
	      return ((0, c), unitSet 1)
	}

word :: String -> NFA Int
word w = 
    NFA { states = mkSet [0 .. length w]
	, starts = mkSet [0]
	, finals = mkSet [length w]
	, trans = listToFM $ do
	      i <- [0 .. length w -1 ]
	      return ((i, (w!!i)), unitSet (i+1))
	}

epsilon  = word ""
letter c = word [ c ]


