module Confluent 

( critical 
, confluent
)

where

import Rewrite

import Monad (guard)
import Words

import Sort

-- confluence -----------------------------------------

overlaps :: [ String ] -> [ String ]
-- all critical words
overlaps lhss = do
    u <- lhss
    v <- lhss

    -- schner fehler:
    -- guard $ p /= q
    -- k <- [0 .. length u - 1]

    -- und so ists richtig:
    k <- [ if u == v then 1 else 0 .. length u - 1 ]

    patch k u v
    
patch :: Int -> String -> String -> [ String ]
patch k u v | length u >= k + length v = do
    guard $ take (length v) (drop k u) == v
    return $ u
patch k u v = do
    let l = length u - k
    guard $ drop k u == take l v
    return $ u ++ drop l v

critical :: RS -> [(String, [String])]
critical rs = do
    w <- overlaps (map (\ (Rule l r) -> l ) rs)
    let ns = normals rs w
    guard $ length ns > 1
    return $ (w, ns)

confluent :: RS -> Bool
confluent = null . critical


pairs :: RS -> [(String, String)]
-- das erste element lnger oder gleich dem zweiten
pairs rs = do
    ys <- map snd $ critical rs 
    let m : rest = sortBy length ys
    r <- rest
    return $ ( r, m )


