-- $Header: /home/joe/scratch/challenger/autotool/fa/Det.hs,v 1.1.1.1 2002/05/24 10:46:47 challenger Exp $

module Det 

where

import NFA_Type
import Trim
import Hull

import Set
import FAU
import FiniteMap



dtrans :: Ord s 
       => [ Char ] -> Set s -> FiniteMap (s, Char) (Set s)
       -> FiniteMap (Set s, Char) (Set s)
dtrans alpha starts tab = 
    let next xs c = unionManySets $ do
		x <- setToList xs
		return $ lookupWithDefaultFM tab emptySet (x, c)
    in	listToFM $ hull alpha next starts
    

det :: Ord s => NFA s -> NFA (Set s)
det a = 
    let alpha = letters a
	trans' = dtrans alpha (starts a) (trans a)
	states' = mkSet $ starts a : ( map fst $ keysFM trans' )
    in	trim $ 
	NFA { states = states'
	    , starts = unitSet $ starts a
	    , trans = mapFM ( \ k xs -> unitSet xs ) trans'
	    , finals = sfilter ( \ xs ->  
		      not $ isEmptySet $ intersect xs (finals a) ) states'
	    }

       
