module Finite 

( finite
)

where

import NFA
import FiniteMap
import Set
import Monad ( guard )

finite :: Ord s => NFA s -> Bool
finite a = and $ do q <- lstarts a; return $ fin a emptySet q

fin :: Ord s => NFA s -> Set s -> s -> Bool
fin a seen p = and $ do
    let now = seen `union` unitSet p
    ((pp, c), qs) <- ltrans a
    guard $ pp == p
    q <- setToList qs
    if q `elementOf` now
       then return $ False
       else return $ fin a now q
