module Hull

( hull
)

where

import Set

hull :: Ord s => [ Char ] -> (s -> Char -> s) -> s -> [ ((s, Char), s) ]
hull alpha next start = inner emptySet [ start ] where
    inner done [] = []
    inner done (x : todo) =
       let done' = union done ( unitSet x )
	   here = do c <- alpha; return ((x, c), next x c)
	   todo' = filter ( not . ( `elementOf` done' ) )
			   ( map snd here ++ todo ) 
       in  here ++ inner done' todo'


