-- $Header: /home/joe/scratch/challenger/autotool/fa/Minus.hs,v 1.1.1.1 2002/05/24 10:46:47 challenger Exp $

module Minus where

-- $Log: Minus.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:47  challenger
-- start
--
-- Revision 1.6  2001/11/19 08:04:22  autotool
-- fehler in Minus.complement behoben
--


import NFA_Type
import Ops ( cross, neu, union )
import Det

import qualified Set
import qualified FAU
import FiniteMap
import Trim
import Det
import Normalize

import Monad ( guard )

complete :: String -> NFA Int -> NFA Int
complete alpha a = 
    let n = neu a
	ns = Set.union (states a) (Set.unitSet n)
    in	NFA { states = ns
	    , starts = if Set.isEmptySet (starts a) 
		       then Set.unitSet n else starts a
	    , finals = Set.minusSet ns (finals a)
	    , trans  = listToFM $ do
	         p <- Set.setToList ns; c <- alpha
		 return $ ( (p, c) 
			  , case lookupFM (trans a) (p, c) of
				 Just qs -> qs
				 Nothing -> Set.unitSet n
			  )
	    }

complement :: String -> NFA Int -> NFA Int
complement alpha a = complete alpha $ normalize $ det a

complement_det :: String -> NFA Int -> NFA Int
complement_det alpha a = complete alpha $ normalize $ a

minus :: NFA Int -> NFA Int -> NFA Int
minus a b = 
    let alpha = letters a
	c = complement alpha b
	d = cross a c
	ok (p, q) =  Set.elementOf p (finals a)	
		  && Set.elementOf q (finals c)
    in	trim $ normalize $ d { finals = FAU.sfilter ok $ states d }

symdiff :: NFA Int -> NFA Int -> NFA Int
-- TODO: effizienter implementieren
symdiff a b = normalize $ union (minus a b) (minus b a)

minus_det :: NFA Int -> NFA Int -> NFA Int
minus_det a b = 
    let alpha = letters a
	c = complement_det alpha b
	d = cross a c
	ok (p, q) =  Set.elementOf p (finals a)	
		  && Set.elementOf q (finals c)
    in	trim $ normalize $ d { finals = FAU.sfilter ok $ states d }



