-- $Header: /home/joe/scratch/challenger/autotool/fa/Properties.hs,v 1.1.1.1 2002/05/24 10:46:47 challenger Exp $

module Properties where

import NFA
import Set
import FiniteMap
import ToDoc
import Monad (guard)

deterministisch 
   :: (ToDoc a, ToDoc [a], Ord a) 
   => NFA a -> Either String String
deterministisch a = 
    let more = do 
	   pxqs @ ((p, x), qs) <- ltrans a
	   guard $ 1 < cardinality qs
	   return pxqs
    in  if null more 
        then  Right "Dieser Automat ist deterministisch."
	else  Left $ unlines 
		   [ "Dieser Automat ist nicht deterministisch,"
		   , "wegen dieser Elemente der bergangsfunktion:"
		   , render $ toDoc more
		   ]

vollstaendig 
   :: (ToDoc a, ToDoc [a], Ord a) 
   => Set Char -> NFA a -> Either String String
vollstaendig sigma a = 
    let miss = do 
	   p <- lstates a
	   x <- setToList sigma
	   let qs = case lookupFM (trans a) (p, x) of
		  Nothing -> emptySet; Just qs -> qs
	   guard $ isEmptySet qs
	   return (p, x)
    in  if null miss
        then  Right "Dieser Automat ist vollstndig."
	else  Left $ unlines 
		   [ "Dieser Automat ist nicht vollstndig."
		   , "Fr diese Argumente ist die bergangsfunktion nicht erklrt:"
		   , render $ toDoc miss
		   ]




