-- $Header: /home/joe/scratch/challenger/autotool/fa/Shuffle.hs,v 1.1.1.1 2002/05/24 10:46:47 challenger Exp $

module Shuffle ( shuffle ) where

import NFA
import Trim

import Set
import FiniteMap
import qualified FAU

shuffle :: (Ord s, Ord t) => NFA s -> NFA t -> NFA (s, t)
shuffle a b = trim $ 
    NFA { states = FAU.cross (states a) (states b)
	, starts = FAU.cross (starts a) (starts b)
	, finals = FAU.cross (finals a) (finals b)
	, trans = addListToFM_C Set.union emptyFM $ do 
	     let la = letters a; lb = letters b
	     pa <- lstates a; pb <- lstates b

	     do -- computation in automaton a
	          c <- la
		  qa <- setToList 
		     $ lookupWithDefaultFM (trans a) emptySet (pa, c)
		  return (((pa, pb), c), unitSet (qa, pb))
	       ++ do -- computation in automaton b
	             c <- lb
		     qb <- setToList 
			$ lookupWithDefaultFM (trans b) emptySet (pb, c)
		     return (((pa, pb), c), unitSet (pa, qb))
	}
  

