module Straight where

import NFA_Type
import Set
import FiniteMap
import FAU (smap)
import Monad (guard)


-- erzeuge quivalenten automaten,
-- bei dem anfangszustnde sofort verlassen
-- und endzustnde nur zum schlu betreten werden

straight :: Ord t => NFA t -> NFA (Int, t)
-- prefix: 0 : anfang, 1 : normal, 2 : ende
straight aut = 
    let n = amap ((,) 1) aut
	st = starts (amap ((,) 0) aut)
	fn = finals (amap ((,) 2) aut)
    in	NFA { states = unionManySets [ st, states n, fn ]
	    , starts = union st 
		     $ smap ((,) 2) 
		     $ intersect (starts aut) (finals aut)
	    , finals = fn
	    , trans = plusFM_C union (trans n) $ collect $ 
		    -- dupliziere kanten von start weg
	            do (p,c,q) <- unCollect $ trans aut
		       guard $ p `elementOf` starts aut
		       return ((0,p),c,(1,q))
		++  -- dupliziere kanten zum ende hin
		    do (p,c,q) <- unCollect $ trans aut
		       guard $ q `elementOf` finals aut
		       return ((1,p),c,(2,q))
	    }
	    