-- $Header: /home/joe/scratch/challenger/autotool/fa/Trim.hs,v 1.1.1.1 2002/05/24 10:46:47 challenger Exp $

module Trim  

( trim )

where

import NFA_Type
import FAU
import Monad (guard)
import Fix
import Set

reachable_states :: Ord s => NFA s -> Set s 
reachable_states a =
    fix ( \ xs -> union xs $ mkSet $ do 
	    ((p, c), qs) <- ltrans a
	    guard $ p `elementOf` xs
	    setToList qs
	) ( starts a )

reachable :: Ord s => NFA s -> NFA s
reachable a = 
    let xs = reachable_states a
    in	afilter (`elementOf` xs) a


productive_states :: Ord s => NFA s -> Set s
productive_states a =
    fix ( \ xs -> union xs $ mkSet $ do
	    ((p, c), qs) <- ltrans a
	    guard $ not $ isEmptySet $ intersect qs xs
	    return p
	) ( finals a )

productive :: Ord s => NFA s -> NFA s
productive a = 
    let xs = productive_states a
    in	afilter (`elementOf` xs) a

trim :: Ord s => NFA s -> NFA s
trim = reachable . productive
