module Words where

import List ( inits, tails, nub, partition )
import Set

alle :: [a] -> Int -> [ [a] ]
alle sigma 0 = return []
alle sigma l | l < 0 = []
alle sigma l = do
    xs <- alle sigma $ l - 1
    x <- sigma
    return $ x : xs

alle_bis :: [a] -> Int -> [[a]]
alle_bis alpha n = do k <- [ 0 .. n]; alle alpha k

subwords :: Eq a => [a] -> [[a]]
subwords w = nub $ do
    u <- tails w
    inits u

closed_subsets ws = css ws [] [] 

css (n : noch) schon nie = 
	-- n nicht nehmen
	css noch schon (n : nie)
	++
	-- n doch nehmen
	let ns = mkSet $ subwords n
	    (ja, nein) = partition ( `elementOf` ns ) (n : noch)
	in  if isEmptySet $ intersect ( mkSet nie ) ns
	    then css nein ( ja ++ schon ) nie
	    else []
css [] schon nie = return schon


shuffle [] ys = [ ys ]
shuffle xs [] = [ xs ]
shuffle (x : xs) (y : ys) =
      do w <- shuffle xs (y : ys); return $ x : w
   ++ do w <- shuffle (x : xs) ys; return $ y : w



cuts :: [a] -> [([a],[a])]
-- all partitions
cuts [] = [([],[])]
cuts (x : xs) = 
    ([], x : xs) : [ (x : ys, zs) | (ys, zs) <- cuts xs ]
