-- vorgnger bzgl. des ersetzungssystems
-- aaa -> a, { aab, baa, bab, bbb } -> b

import NFA

import Inter
import Analyze

import Minimize
import Normalize
import Trim
import Shortest

import Ops
import Basic

import List (tails, groupBy)

va = minimize $ read "a(aa)*" :: NFA Int

vb = minimize $ read "(aa)* ( b + ( b ((a+b)(a+b))* (a+b) b )) (aa)*" 
	:: NFA Int

ns = [ "", "a", "b", "aa", "ab", "ba", "bb", "aba", "abb", "bba", "abba" ]

aut :: String -> NFA Int
aut n = minimize
      $ foldr ( \ x y -> normalize $ dot x y ) epsilon
      $ map ( \ x -> case x of 'a' -> va; 'b' -> vb ) n

auts = do n <- ns; return (n, aut n)

gesamt = minimize $ foldr1 ( \ x y -> normalize $ union x y ) $ map snd auts

schnitte = do
    (v, a) : rest <- tails auts
    (w, b) <- rest
    let ab = minimize $ normalize $ intersection a b
    return (v, w, ab, analyze ab)
