module Arithmetik 


where

import Builtin

plus  = lift2 $ (+) 
minus = lift2 $ \ x y -> max 0 (x - y) 
mal   = lift2 $ (*) 
durch = lift2 $ \ x y -> if 0 == y then 0 else x `div` y 
hoch  = lift2 $ (^)

sqroot  = lift1 $ \ x -> truncate ( sqrt ( fromIntegral x ) )
log2	= lift1 $ \ x -> if 0 == x then 0 
				   else truncate ( logBase 2 (fromIntegral x))

arithmetik :: Builtins
arithmetik = builtins
	   [ ( "plus", plus )
	   , ( "minus", minus )
	   , ( "mal", mal )
	   , ( "durch", durch )
	   , ( "hoch", hoch )
	   , ( "sqrt", sqroot )
	   , ( "log", log2 )
	   ]
