module Builtin 


where

import FiniteMap
import Fun

type Builtin =  ( Int, [ Integer ] -> Integer )
type Builtins = FiniteMap String Builtin

----------------------------------------------------------------------------

lift2 :: ( Integer -> Integer -> Integer ) -> Builtin
lift2 f = ( 2, \ [ x, y ] -> f x y )

lift1 :: ( Integer -> Integer ) -> Builtin 
lift1 f = ( 1, \ [ x ] -> f x )

lift0 :: Integer -> Builtin
lift0 f = ( 0, \ [ ] -> f )

unlift2 :: Builtin -> ( Integer -> Integer -> Integer ) 
unlift2 ( 2, f ) = \ x y -> f [ x, y ]

unlift1 :: Builtin -> ( Integer -> Integer ) 
unlift1 ( 1, f ) = \ x -> f [ x ]


builtins :: [ (String, Builtin) ] -> Builtins
builtins nfs = listToFM $ do
    ( name, ( a, f ) ) <- nfs
    return ( name, ( a , f ) )

beide :: Builtins -> Builtins -> Builtins
beide = plusFM_C (error "gemeinsamer builtin")


      