module Check where

import Fun
import Builtin
import Typeof
import Vorrechnen
import Table

import Auswertung ( und, mu )
import Right
import Report
import FiniteMap

check :: Int 
      -> Builtins
      -> ( [ Integer ] -> Integer )
      -> [ Integer ]
      -> Fun
      -> Either String String
check cut builtins  vorbild args student = 
    let ( comm, mres ) = vorrechnen cut builtins student args
	soll = vorbild args
    in	case mres of
	     Nothing -> Left $ unlines $ comm ++ 
		     [ "nach " ++ show cut ++ " Schritten noch kein Resultat" ]
	     Just res -> 
		  if soll == res
		  then Right $ unlines $ comm ++
		     [ "Resultat ist korrekt." ]
		  else Left $ unlines $ comm ++
		     [  "Resultat " ++ show res 
		     ++ ", gefordert ist " ++ show soll ]

checks :: Int 
      -> Builtins
      -> String
      -> [ [ Integer ] ]
      -> Fun
      -> IO String
checks cut b name argss student = do
    let Just (arity, vorbild) = lookupFM b name
    let b' = delFromFM b name
    let tyck = case typeof student of
	    Fail msg -> Left $ "Fehler bei der Typprfung:\n" ++ msg
	    OK ar -> 
	       if ar /= arity
	       then Left $ "Die Funktion ist " ++ show ar ++ "-stellig,"
			 ++ " soll aber " ++ show arity ++ "-stellig sein."
	       else Right $ "Die Funktion hat den richtigen Typ."
			  ++ "\n\n" ++ tafel ar 12 1000 b student
    mu tyck        
	$ mu ( und $ do args <- argss
			 return $ check cut b vorbild args student )
	      $ right

    
