module Logik where


import Builtin

jaa, nee :: Integer
jaa = 1; nee = 0

---------------------------------------------------------------------------

wahr :: Bool -> Integer
wahr x = if x then jaa  else nee

rhaw :: Integer -> Bool
rhaw x = (x > 0)

blift1 :: (Bool -> Bool) -> Builtin
blift1 f = lift1 $ ( wahr . f . rhaw )

blift2 :: (Bool -> Bool -> Bool) -> Builtin
blift2 f = lift2 $ \ x y -> wahr ( f (rhaw x) (rhaw y) )

---------------------------------------------------------------------------

ja, nein :: Builtin
ja   = lift0 $ jaa
nein = lift0 $ nee

nicht       = blift1 not
und         = blift2 (&&)
oder        = blift2 (||)
pfeil       = blift2 (<=)
doppelpfeil = blift2 (==)

logik :: Builtins
logik = builtins
      [ ( "ja", ja ), ( "nein", nein )
      , ( "nicht" , nicht )
      , ( "und", und ), ( "oder", oder )
      , ( "pfeil", pfeil ), ( "doppelpfeil", doppelpfeil )
      ]
