module Prim where

import Builtin

import Logik (wahr)

primes = sieve ( 2 : [ 3, 5 .. ] )
    where sieve (x : ys) = x : sieve (filter ( \ y -> 0 < y `rem` x )  ys )

rest = lift2 $ \ x y -> if 0 == y then 0 else x `rem` y 
teilbar = lift2 $ \ x y ->  wahr ( 0 == x && 0 == y 
		    || ( 0 < y && 0 == x `rem` y ) )
pr    = lift1 $ \ k ->   (0 : primes) !! fromInteger k 
prim  = lift1 $ \ x -> wahr $  x == (head $ dropWhile (< x) primes )
fak   = lift1 $ \ x -> foldr (*) 1 [ 1 .. x ] 

primzahlen :: Builtins
primzahlen = builtins
	     [ ( "rest", rest) , ( "teilbar", teilbar ) 
	     , ( "pr", pr ) , ( "prim"  ,  prim ) , ( "fak", fak ) ]


