module Vorrechnen where

import Fun
import Eval
import Builtin
import Report

vorrechnen :: Int 
	   -> Builtins -> Fun -> [ Integer ] -> ( [ String ], Maybe Integer )
vorrechnen cut b f args =
    let ( track, cache, result ) = evaluate b f args
        ( kurz, lang ) = splitAt cut track
        vis = 5
        (v, mh) = splitAt vis kurz
        (m, h) = splitAt (max 0 $ length mh - vis) mh
	mm = if null m then []
	     else [ ".. ( " ++ show (length m) ++ " Zeilen ) .. " ] 
    in	( v ++ mm ++ h
	, if null lang
	  then Just result
	  else Nothing
	)

durchrechnen :: Int -> Builtins -> Fun -> [ Integer ] -> Report Integer
durchrechnen cut b f args =
    case vorrechnen cut b f args of
        ( msg, Nothing ) -> fail $ unlines msg
	( msg, Just x  ) -> return x
