-- $Header: /home/joe/scratch/challenger/autotool/grammatik/CF_Check.hs,v 1.1.1.1 2002/05/24 10:46:47 challenger Exp $

module CF_Check 

-- $Log: CF_Check.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:47  challenger
-- start
--
-- Revision 1.6  2002/01/14 23:11:14  autotool
-- anpassungen fr serie 6
--
-- Revision 1.5  2001/11/29 13:41:20  autotool
-- CF_advanced: besserer parser, hrtere tests
--
-- Revision 1.4  2001/11/28 08:38:04  autotool
-- keine lngeren mutanten als originale
--

where

import Grammatik 
import Epsfrei
import Kettenfrei
import qualified Chomsky as C


-- eins der beiden imports auswhlen:

-- fr jedes wort einzeln das CYK-array ausrechnen
-- (besser fr hugs??)
-- import CYK

-- gemeinsamen speicher fr alle teilwrter
-- (mte eigentlich hashtabelle benutzen, FiniteMaps sind zu langsam?)
import DPL_CYK

-- end auswahl

import Size
import Wort
import Edit

import List (partition, nub, sortBy)
import FilterBound

import Right
import Wrong
import ToDoc
import Random


cf_check_one_word :: Grammatik -> String -> Bool
cf_check_one_word g w = 
    let ch = C.chomsky $ kettenfrei $ epsfrei $ g
    in	accepted ch w


cf_check :: (String -> Bool) -> [ String ] -> Grammatik -> IO String
cf_check p ws g = do
    let large = maximum [ length w | w <- ws ]
    ms <- mapM edits $ ws ++ ws
    let mutants = filter ( \ w -> length w <= large ) ms
    cf_check_nomutate p ( ws ++ mutants ) g

cf_check_nomutate :: (String -> Bool) -> [ String ] -> Grammatik -> IO String
cf_check_nomutate p ws g = do
    let (yeah, noh) = partition p $ nub ws
    cf_yeah_noh yeah noh g

cf_yeah_noh :: [ String ] -> [ String ] -> Grammatik -> IO String
cf_yeah_noh yeah0 noh0 g = do
    let arrange = sortBy (\ x y -> compare (length x, x) (length y, y))
    let [ yeah, noh ] = map arrange [ yeah0, noh0 ]

    let msg = "OK # Size: " ++ show (size g)

    let snip = id -- take 5 -- arbitrary
 
    let ch = C.chomsky $ kettenfrei $ epsfrei $ g

    putStrLn $ unlines
	     [ ""
	     , "Ich wrfele einige Wrter der Zielsprache"
	     , render $ toDoc yeah
	     , "und prfe, ob sie von Ihrer Grammatik erzeugt werden."
	     , ""
	     ]

    let achyeah = accepteds ch yeah
    -- print achyeah

    let yeah_falsch = snip 
		    $ map ( \ (w, f) -> w )
		    $ filterBound 5 ( \ (w, f) -> not f ) 
		    $ achyeah
    if null yeah_falsch 
       then putStrLn $ "... OK"
       else do putStrLn $ unlines
			[ "Ihre Grammatik erzeugt unter anderem diese Wrter NICHT:" ]
	       putStrLn $ render $ toDoc yeah_falsch


    if not $ null yeah_falsch
       then wrong
       else do
	    putStrLn $ unlines
		     [ ""
		     , "Ich wrfele einige Wrter aus dem Komplement der Zielsprache"
		     , render $ toDoc noh
		     , "und prfe, da sie wirklich nicht von Ihrer Grammatik erzeugt werden."
		     , ""
		     ]
	    let achnoh = accepteds ch noh
	    -- print achnoh
	    let noh_falsch = snip 
		    $ map ( \ (w, f) -> w )
		    $ filterBound 5 ( \ (w, f) -> f ) 
		    $ achnoh
	    if null noh_falsch 
	       then putStrLn $ "... OK"
	       else do 
		    putStrLn $ unlines
			     [ "Ihre Grammatik erzeugt unter anderem diese Wrter DOCH:" ]
		    putStrLn $ render $ toDoc noh_falsch

	    if null (yeah_falsch ++ noh_falsch)
	       then right_with msg else wrong






