-- $Header: /home/joe/scratch/challenger/autotool/grammatik/CYK.hs,v 1.1.1.1 2002/05/24 10:46:47 challenger Exp $

module CYK

( accepted, accepteds
, cyk
)

-- Cocke/Younger/Kasami-Parser

-- $Log: CYK.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:47  challenger
-- start
--
-- Revision 1.4  2001/11/29 13:41:20  autotool
-- CF_advanced: besserer parser, hrtere tests
--
-- Revision 1.3  2001/11/28 07:27:11  autotool
-- benutze DPL in CYK/CF_Chomsky
--
-- Revision 1.2  2001/11/27 20:57:28  autotool
-- CYK: benutze Simple_Set statt Set (ist lazier)
--
-- Revision 1.1  2001/11/18 23:57:05  autotool
-- neu: chomsky-form, greibach-form, CYK-parser und hilfsprogramme
--

where

import Array

import Chomsky

-- eins der beiden auswhlen:

-- benutzt FiniteMap (besser fr hugs?)
-- import CYK_Tables

-- benutzt Arrays (auf jeden fall besser fr ghc -O)
import CYK_Arrays

-- end auswahl



-- accepted :: Ix a => Chomsky a -> String -> Bool
accepted :: Chomsky Int -> String -> Bool
accepted ch w = 
    let a   = cyk (rules ch) w
	top = a ! (0, length w)
    in	start ch `elementOf` top

-- accepteds :: Ix a => Chomsky a -> [ String ] -> [ (String, Bool) ]
accepteds :: Chomsky Int -> [ String ] -> [ (String, Bool) ]
accepteds ch ws = do
    w <- ws
    return (w, accepted ch w)

-----------------------------------------------------------------------

-- cyk :: Ix a => Rules a -> String -> Array (Int,Int) (Set a)
cyk :: Rules Int -> String -> Array (Int,Int) (Set Int)
cyk rules w =
    let n = length w
	ct = ctable rules
	vt = vtable rules
	b = ((0,0), (n,n))
	fun (i, k) = 
	    if i >= k then emptySet
	    else if i == k - 1 then ctable_lookup ct (w !! i)
	    else mkSet $ do
	        j <- [ i+1 .. k-1 ]
		u <- setToList $ a!(i,j)
		v <- setToList $ a!(j,k)
		setToList $ vtable_lookup vt (u,v)
	a = array b $ do 
	  p <- range b
	  return (p, fun p)
    in	a


