-- $Header: /home/joe/scratch/challenger/autotool/grammatik/Grammatik.hs,v 1.1.1.1 2002/05/24 10:46:47 challenger Exp $

module Grammatik where

-- $Log: Grammatik.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:47  challenger
-- start
--
-- Revision 1.5  2001/12/01 14:47:33  autotool
-- prekompilierte grader
--
-- Revision 1.4  2001/11/29 09:02:01  autotool
-- neu: deriving Read
--
-- Revision 1.3  2001/11/18 23:57:05  autotool
-- neu: chomsky-form, greibach-form, CYK-parser und hilfsprogramme
--
-- Revision 1.2  2001/11/11 17:10:09  autotool
-- ToDoc: instance ToDoc String
--    deswegen viele Typ-nderungen berall
--    (benutzt overlapping instances)
-- grammatik/* : Typ benutzt jetzt Mengen statt Listen
--

import Set
import ReadSet

import Size
import ToDoc

data Grammatik = Grammatik
	       { terminale      :: Set Char
	       , nichtterminale :: Set Char
	       , startsymbol	:: Char
	       , regeln		:: Set (String, String) 
	       }
     deriving (Read,Show)

terms = setToList . terminale
vars  = setToList . nichtterminale
rules = setToList . regeln

-- instance Show Grammatik where show = render . toDoc

instance Size Grammatik where size = cardinality . regeln

instance ToDoc Grammatik where
    toDoc a = 
	 let pterm = text "terminale" <+> equals <+> toDoc (terminale a)
	     pnicht = text "nichtterminale" <+> equals <+> toDoc (nichtterminale a)
	     pstart = text "startsymbol" <+> equals <+> toDoc (startsymbol a)
	     pregeln  = text "regeln" <+> equals <+> toDoc (regeln a)

	 in      text "Grammatik" 
	     <+> braces ( fsep $ punctuate comma 
				    [ pterm, pnicht, pstart, pregeln] )




