module Links_Ableitung where

import Monad (guard)
import List (intersperse)
import Set
import Schichten
import Doppelte
import Wort
import Grammatik


import Mehrdeutig
import Ableitung


-- nur die erste (d. h. am weitesten linke) Ersetzung ausfhren
-- das hat eigentlich nur fr CF-Grammatiken Sinn,
-- das prfen wir hier jedoch nicht

links_schritt :: Maybe Int
	-> Grammatik -> Ableitung -> Set Ableitung 
links_schritt schranke g a = unionManySets 
			   $ take 1 
			   $ filter (not . isEmptySet)
			   $ do
    let w = car a
    (vorn, hinten) <- zerlegungen w
    return $ mkSet $ do
        (links, rechts) <- rules g
	let (mitte, rest) = splitAt (length links) hinten
	guard $ mitte == links    
	let w' = vorn ++ rechts ++ rest
	guard $ case schranke of Nothing -> True; Just n -> length w' <= n
	return $ cons w' a

links_ableitungen :: Maybe Int -> Grammatik -> [ Ableitung ]
links_ableitungen schranke g = do
    ws <- schichten (links_schritt schranke g) 
		    (cons [ startsymbol g ] nil)
    w <- setToList ws
    guard $ and [ x `elementOf` terminale g | x <- car w ]
    return w

alle_links_ableitungen :: Maybe Int -> Grammatik -> [ Ableitung ]
alle_links_ableitungen schranke g = do
    ws <- schichten (links_schritt schranke g) 
		    (cons [ startsymbol g ] nil)
    w <- setToList ws
    -- guard $ and [ x `elem` terminale g | x <- car w ]
    return w

mehrdeutige_links_ableitungen 
    ::  Maybe Int -> Grammatik -> [ (Ableitung, Ableitung) ]
mehrdeutige_links_ableitungen schranke g =
    doppelteBy car $ links_ableitungen schranke g

