module Vergleiche where

import Wort
import Set
import FilterSet
import Grammatik
import Size
import Zeige
import Ableitung
import Schichten

import Wrong
import Right

import Typen (typ1)


vergleiche :: Int -> Set String -> Int -> Grammatik -> IO String
vergleiche lschranke ziel gschranke g = do
    let ok = "OK # Size: " ++ show (size g)
    vergleiche_with ok lschranke ziel gschranke g

vergleiche_with :: String -> Int -> Set String -> Int -> Grammatik -> IO String
vergleiche_with msg lschranke ziel gschranke g = do
    zeige (Just gschranke) g
    res <- vergleiche0 msg lschranke ziel gschranke g
    return res

vergleiche0 msg lschranke ziel gschranke g = do

    let mono = case typ1 g of Right _ -> True; Left _ -> False
    let mschranke = if mono then lschranke else gschranke

    putStrLn $ unlines
	[ ""
	, "Ich vergleiche jetzt Ihre Sprache L(G) mit der Zielsprache"
	, "und bercksichtige nur Wrter bis zur Lnge " ++ show lschranke ++ ","
	, "die durch Ableitungen enstehen, bei denen alle Wortformen"
	, "hchstens die Lnge " ++ show mschranke ++ " haben."
       ]

    let lg = filter ( (<= lschranke) . length )
	   $ erzeugte_sprache (Just mschranke)
	   $ g
    let lk = filterSet ( ( <= lschranke) . length ) ziel

    putStrLn $ "\nIch prfe, ob alle (kleinen) Wrter in L(G) zur Zielsprache gehren."
    let lg_minus_lk = filter ( not . (`elementOf` lk) )
		    $ lg
    let falsch = take 5 lg_minus_lk
    if not $ null falsch
       then do putStrLn $ "Wenigstens diese w in L(G) sind falsch " 
			       ++ show falsch
	       wrong
       else do

    putStrLn $ "Das ist der Fall."

    putStrLn $ "\nIch prfe, ob alle (kleinen) Wrter der Zielsprache zu L(G) gehren."

    let lk_lg = lk `minusSet` mkSet lg
    if not $ isEmptySet lk_lg
       then do putStrLn $ "Ihr L(G) erzeugt (wenigstens) diese Wrter der Zielsprache nicht "
			       ++ hint (setToList lk_lg)
	       wrong
       else do

    putStrLn $ "Das ist der Fall.\n"
    right_with msg


