module Graph_Clique where

import Graph
import Graph_Util

import Set
import FiniteMap

import Auswertung
import Right 

-------------------------------------------------------------------------------

istClique :: Ord a => Graph a -> [a] -> Bool
istClique g x = symmetrisch (teil g x) == clique_auf x

-------------------------------------------------------------------------------

check graph k msg student = do
   let mKn    = setToList (mehrfacheKnoten student)
   let mehrKn = case mKn of
                [] -> Right $ "Keine Knoten sind mehrfach in der Clique enthalten."
                _  -> Left  $ "Folgende Knoten sind mehrfach in der Clique enthalten:\n"
                              ++ show mKn

   let eKn    = setToList (mkSet student `minusSet` 
                           mkSet [ x | x<-(knotenl graph) ])
   let exctKn = case eKn of
                [] -> Right $ "Alle Knoten gehren zum Graph."
                _  -> Left  $ "Folgende Knoten gehren nicht zum Graph:\n"
		              ++ show eKn

   let istC   = case istClique graph student of
                True  -> Right $ "Alle bentigten Kanten sind im Graph enthalten." 
                                 ++ " Das ist wirklich eine Clique."
                False -> Left  $ unlines
                      $  [ "Folgende Kanten sind nicht im Graph enthalten:\n"
                         , show (mkSet (map ( \ (x,y) -> ka x y ) (zip student (tail student))) `minusSet` (kanten graph))
                         ]

   let istGr  = case length student == k of
                True -> Right  $ "Das ist eine der grssten Cliquen."
                False -> Left  $ "Das ist eine Clique der Lnge "
                                 ++ show (length student)
                                 ++ ". Es gibt jedoch noch grssere Cliquen."

   putStrLn $ unlines 
     $ [ "Ich bin der automatische Korrektor fr Aufgabe " ++ msg
       , ""
       , "Gesucht ist eine grsste Clique eines Graphen."
       , "" -- , show graph
       , "Ihre Clique lautet:"
       , show student
       ]

   mu mehrKn $ mu exctKn $ mu istC $ mu istGr $ right
