module Graph_Color where

import Graph
import Graph_Util

import Set
import FiniteMap

import Auswertung
import Right

-------------------------------------------------------------------------------

istFrbung :: Ord a => Graph a -> [[a]] -> Bool
istFrbung g xs = mkSet (gleichfarbKanten g xs) == mkSet [ mkSet [] ]
                  &&
                  isEmptySet (mehrfacheKnoten xs)
                  &&
                  isEmptySet (fehlendeKnoten g 
			      (setToList (mkSet [ y | x <- xs, y <- x  ]))
                             )

gleichfarbKanten :: Ord a => Graph a -> [[a]] -> [ Set (Kante a) ]
gleichfarbKanten g = map ( \ l -> kanten ( teil g l ) )

-------------------------------------------------------------------------------

check graph k msg student = do
   let l      = length student
   let fCount = case l == k of
                True  -> Right $ "Das sind " ++ show l ++ " Farben."
                False -> Left  $ "Das sind " ++ show l ++ " Farben. "
                                  ++ "Gesucht ist aber eine " 
                                  ++ show k ++ "-Frbung."

   let alleKn = [ x | l<-student, x<-(setToList(mkSet l)) ]

   let eKn    = setToList (mkSet alleKn `minusSet` 
                           mkSet [ x | x<-(knotenl graph) ])
   let exctKn = case eKn of
                [] -> Right $ "Alle gefrbten Knoten gehren zum Graph."
                _  -> Left  $ "Folgende gefrbte Knoten gehren nicht zum Graph:\n"
		              ++ show eKn

   let fKn    = setToList (fehlendeKnoten graph alleKn)
   let fehlKn = case fKn of
                [] -> Right $ "Alle Knoten sind gefrbt."
                _  -> Left  $ "Folgende Knoten sind nicht gefrbt:\n"
		              ++ show fKn

   let mKn    = setToList (mehrfacheKnoten alleKn)
   let mehrKn = case mKn of
                [] -> Right $ "Keine Knoten sind mit mehr als einer Farbe gefrbt."
                _  -> Left  $ "Folgende Knoten sind mit mehr als einer Farbe gefrbt:\n"
                              ++ show mKn

   let istF   = case istFrbung graph student of
                True  -> Right $ "Keine Knoten gleicher Farbe sind verbunden." 
                                 ++ "Das ist wirklich eine "
                                 ++ show k ++ "-Frbung."
                False -> Left  $ unlines
                      $  [ "Folgende Knoten gleicher Farbe sind verbunden:" ]
                         ++ nice (gleichfarbKanten graph student)

   putStrLn $ unlines 
     $ [ "Ich bin der automatische Korrektor fr Aufgabe " ++ msg
       , ""
       , "Gesucht ist eine " ++ show k ++ "-Frbung eines Graphen."
       , "" -- , show graph
       , "Ihre Frbung lautet:"
       ] ++ nice student

   mu fCount $ mu fehlKn $ mu mehrKn $ mu exctKn $ mu istF $ right

nice :: Show a => [ a ] -> [ String ]
nice xs = [ "Farbe " ++ show n ++ ": " ++ show f
          | (n,f)<-(zip [1..] [ f | f <- xs ]) 
          ]
