module Graph_Hamilton_Solve where

import Graph
import Graph_Util
import Graph_Hamilton

import Set
import FiniteMap

-------------------------------------------------------------------------------

lngereWege :: Ord a => Graph a -> [[a]] -> [[a]]
lngereWege g xs =
    setToList ( mkSet( filter ( \l -> isEmptySet (mehrfacheKnoten l) )
                              [ l ++ [x]
                              | l <- xs, x <- knotenl g, istWeg g (l ++ [x])
                              ]
                     )
              )

lngsteWege :: Ord a => Graph a -> [[a]] -> [[a]]
lngsteWege g xs =
   let lW = lngereWege g xs
   in case lW of
           []  -> xs
           lWg -> case length (head lWg) == length (knotenl g) of
                  True  -> lWg
                  False -> lngsteWege g lWg
 
alleHamiltons :: Ord a => Graph a -> [[a]]
alleHamiltons g = [ h | h <- lngsteWege g [[head (knotenl g)]]
                      , istHamilton g h ]