-- $Header: /home/joe/scratch/challenger/autotool/lang/Language.hs,v 1.1.1.1 2002/05/24 10:46:48 challenger Exp $

module Language

where

-- $Log: Language.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.2  2001/12/05 21:11:31  autotool
-- lang/*
--
-- Revision 1.1  2001/12/04 13:04:10  autotool
-- neu: pump/* lang/*
--

import Wort
import ToDoc
import Set
import Monad (guard)
import Random

data Language = Language
	      { abbreviation :: String
	      , alphabet     :: Set Char

	      -- testet Mitgliedschaft in Sprache
	      , contains     :: String -> Bool

	      -- sample  c n
	      -- wrfelt maximal c Wrter der Sprache
	      -- mit Lnge == n
	      , sample       :: Int -> Int -> IO [ String ]

	      }

instance ToDoc Language where
    toDoc l = text ( abbreviation l )
instance Show Language where
    show = render . toDoc


random_sample :: Language -> Int -> Int -> IO [ String ]
-- wrfeln und testen
-- nur sinnvoll, wenn sprache gengend dicht ist
random_sample l c n = do
    ws <- sequence $ replicate c $ someIO (setToList $ alphabet l) n
    return $ filter (contains l) ws

       
samples :: Language -> Int -> Int -> IO [ String ]
-- wrfelt genau (!) c Wrter der Sprache l, mit Lnge >= n,
-- dabei von jeder festen lnge hchstens sqrt c viele
-- das klappt nur, wenn die sprache unendlich ist
samples l c n | c > 0 = do
    let m = truncate $ sqrt $ fromIntegral c    
    here <- sample l m n 
    let d = 1 -- d <- randomRIO (1, 3)
    there <- samples l (c - length here) (n + d)
    return $ here ++ there
samples l c n = return []
    
