module DFA 


( DFA
, DFATable

, module Set 
, module FiniteMap
, module Machine
)

where

import Set
import FiniteMap

import Tape
import Machine


newtype DFATable q s 
    = DFATable ( FiniteMap (q,s) q )

type DFA q s = Machine q s Index

instance (Show q, Show s) => Show (DFATable q s) where
    showsPrec p (DFATable tab) = 
        showsPrec p (fmToList tab)

instance Trans DFATable Index where
    trans (DFATable tab) 
        = \ (q, s) -> do q' <- case lookupFM tab (q, s)
				    of Just q' -> [q']; Nothing -> []
			 return (q', s, right)






