module Execute

( Machine (..)
, execute
, finals
)

where

import Set
import FiniteMap

import Machine
import Memory
import Pointed
import Blank
import Search


step :: (Ord q, Ord s, Memory m p, Blank s) 
	=> Machine q s s p -> Pointed m p q s -> [ Pointed m p q s ]

step m p = do let q = getstate p
	      let s = getchar  p
	      (q', s', f) <- lookupWithDefaultFM (transitions m) [] (q, s)
	      return $ move f 
		     $ putstate q' 
		     $ putchar s'
		     $ p

execute :: (Ord q, Ord s, Memory m p, Blank s, Top p) 
       => Machine q s s p -> m s -> Int ->  [ Pointed m p q s ]
execute machine mem count = do
    let q = start machine
	p = putstate q $ pointed mem
    layer <- take count $ bfs (step machine) p
    p' <- layer
    return p'

finals ::  (Ord q, Ord s, Memory m p, Blank s, Top p, Ord q) 
       => Machine q s s p -> m s -> Int -> [ Pointed m p q s ]
-- run for a certain time,
-- output only configurations with final states
finals machine mem count
    = filter ( \ p -> getstate p `elementOf` final machine )
    $ execute machine mem count

