module NPDA

-- nondeterministic pushdown automaton

( NPDA
, NPDATable

, module Set 
, module FiniteMap
, module Machine
)

where

import Set
import FiniteMap

import Tape
import Machine


newtype NPDATable q tape stack -- two distinct alphabets  
    = NPDATable ( FiniteMap (q,tape,stack) [ (q, Maybe stack) ] )

type NPDA q s = Machine q s Index

instance (Show q, Show s) => Show (NPDATable q s) where
    showsPrec p (NPDATable tab) = 
        showsPrec p (fmToList tab)

instance Trans NPDATable Index where
    trans (NPDATable tab) 
        = \ (q, s) -> do q' <- lookupWithDefaultFM tab [] (q, s)
			 return (q', s, right)






