module Pointed 

( Pointed
, pointed
, getchar, putchar, move
, getstate, putstate 
)

where

import Blank
import Memory		
import Empty


data Pointed m p q s = 
     Pointed { contents :: m s
	      , pointer :: p
	     , state :: q
	      } deriving Show

instance (Empty (m s), Top p) => Empty (Pointed m p q s) where
    empty = Pointed { contents = empty, pointer = top, state = undefined }

pointed :: (Memory m p, Top p) => m s -> Pointed m p q s
pointed c = Pointed { contents = c, pointer = top, state = undefined }

getchar :: (Memory m p, Blank s) => Pointed m p q s -> s
getchar p = get (contents p) (pointer p)

putchar :: (Memory m p, Blank s) => s -> Pointed m p q s -> Pointed m p q s
putchar x p = p { contents = put (contents p) (pointer p) x }

move :: (Memory m p) => (p -> p) -> (Pointed m p q s -> Pointed m p q s)
move f p = p { pointer = f (pointer p) }

getstate :: (Memory m p, Blank s) => Pointed m p q s -> q
getstate m = state m

putstate :: (Memory m p, Blank s) => q -> Pointed m p q s -> Pointed m p q s
putstate q m = m {  state = q }


