module Stateful where

( Stateful
, get, put
)

where

import Blank
import Memory		

data Pointed m p q s = 
     Pointed { contents :: m s
	      , pointer :: p
	     , state :: q
	      }

getchar :: (Memory m p, Blank s) => Pointed m p q s -> s
getchar p = get (contents p) (pointer p)

putchar :: (Memory m p, Blank s) => Pointed m p q s -> s -> Pointed m p q s
putchar p x = p { contents = put (contents p) (pointer p) x }

move :: (Memory m p) => (p -> p) -> (Pointed m p q s -> Pointed m p q s)
move f p = p { pointer = f (pointer p) }

getstate :: (Memory m p, Blank s) => Pointed m p q s -> q
getstate m = state m

putstate :: (Memory m p, Blank s) => Pointed m p q s -> q -> Pointed m p q s
putstate m q = m {  state = q }


