module Tape 

( Tape
, Index
, left, right, stay
)

where

import FiniteMap
import Blank
import Memory
import Empty

newtype Index = Index Int deriving (Eq, Ord, Show)

newtype Tape s = Tape ( FiniteMap Index s ) 

instance Show s => Show (Tape s) where
    showsPrec p (Tape t) = showsPrec p $ fmToList $ t

instance Memory Tape Index where
    get (Tape c) p   = lookupWithDefaultFM c blank p
    put (Tape c) p x = Tape $ addToFM c p x 

instance Empty (Tape s) where empty = Tape empty

instance Top Index where 
    top = Index 0 -- rather arbitrary start position

left, right, stay :: Index -> Index
left (Index i) = Index (i - 1)
right (Index i) = Index (i + 1)
stay (Index i) = Index i
