module Turing

( turing
, Turing
, Dir (..)

, module Set 
, module FiniteMap
, module Machine
, module Table
)

where

import Set
import FiniteMap

import Tape
import Machine
import Table

data Dir = L | S  | R deriving (Eq, Ord, Show)

meaning :: Dir -> (Index -> Index)
-- der Witz ist, da Index nicht exportiert wird
-- (von diesem modul) oder nur abstrakt (von anderen) (welchen berhaupt?)
meaning d = case d of
    L -> left; S -> stay; R -> right

type Turing q s s' = FiniteMap (q, s) [(q, s', Dir)]

turing :: Turing q s s' -> Table q s s' Index
turing = mapFM ( \ _ qsds -> map ( \ (q, s, d) -> (q, s, meaning d) ) qsds )







