????

module TwoTape

( TwoTape
, TwoTapeTable
, Dir (..)

, module Set 
, module FiniteMap
, module Machine
)

where

import Set
import FiniteMap

import Tape
import Machine

data Dir = L | S  | R deriving (Eq, Ord, Show)

meaning :: Dir -> (Index -> Index)
-- der Witz ist, da Index nicht exportiert wird
-- (von diesem modul) oder nur abstrakt (von anderen) (welchen berhaupt?)
meaning d = case d of
    L -> left; S -> stay; R -> right

newtype TwoTapeTable q top low -- zwei verschiedene Alphabete 
    = TwoTapeTable ( FiniteMap (q,(top,low)) [ (q,(top,low),(Dir,Dir)) ] )

type TwoTape q s = Machine q s (Index, Index)

instance (Show q, Show s) => Show (TwoTapeTable q s) where
    showsPrec p (TwoTapeTable tab) = 
        showsPrec p (fmToList tab)

instance Trans TwoTapeTable Index where
    trans (TwoTapeTable tab) 
        = \ (q, s) -> do (q', s', d) <- lookupWithDefaultFM tab [] (q, s)
			 return (q', s', meaning d)






