module Akzeptieren 

where

-- $Log: Akzeptieren.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.3  2002/01/16 18:08:13  mrahn
-- - Serie 6 fr Kompilation zurechtgebaut
--
-- Revision 1.2  2002/01/13 23:03:33  autotool
-- kellerautomaten: nutze toDoc, akzeptanzmodus sichtbar
--

import NPDA
import Konfiguration
import Nachfolger
import Vorganger
import Vorrechnen
import ToDoc
import Monad (guard)


akzeptierend :: (Ord x, Ord y, Ord z)
    => Int -> NPDA x y z -> [x] -> [ Konfiguration x y z ]
akzeptierend cut a xs = do
    k <- take cut $ nachfolger a (start_konfiguration a xs)
    guard $ eingabe k == []
    guard $ case akzeptiert a of
	  Leerer_Keller -> keller k == []
	  Zustand zs -> zustand k `elementOf` zs
    return k

----------------------------------------------------------------------


mit_leerem_keller_akzeptierte_eingaben
    :: (Ord x, Ord y, Ord z)
    => NPDA x y z -> [ Konfiguration x y z ]
mit_leerem_keller_akzeptierte_eingaben a = take 10 $ do
    let ks = leere_keller_konfigurationen a
    k <- take 1000 $ vorganger a ks
    guard $ keller k == [ startsymbol a ]
    guard $ zustand k == startzustand a
    return k

----------------------------------------------------------------------

positiv_liste :: (Ord x, Ord y, Ord z,
	 	  ToDoc x, ToDoc y, ToDoc z
	   ,	 ToDoc [x], ToDoc [y], ToDoc [z]) 
	      => Int 
	      -- -> (Int -> NPDA x y z -> [x] -> [ Konfiguration x y z ])
	      -> NPDA x y z -> [[x]] -> Either String String
positiv_liste cut a xss = case take 3 $
    do xs <- xss
       let ks = akzeptierend cut a xs
       guard $ null ks -- d. h. flschlicherweise nicht akzeptiert
       return xs
  of []  -> Right $ "alle Wrter aus der Positiv-Liste wurden akzeptiert"
     xss -> Left  $ render $ fsep 
		  $ [ text "diese Wrter der Positiv-Liste wurden nicht akzeptiert:"
		    , toDoc xss 
		    , fsep $ map (vorrechnen a) xss 
		    ] 
		    

negativ_liste :: (Ord x, Ord y, Ord z,
	 	   ToDoc x, ToDoc y, ToDoc z
	   ,	 ToDoc [x], ToDoc [y], ToDoc [z]) 
	      => Int 
	      -- -> (Int -> NPDA x y z -> [x] -> [ Konfiguration x y z ])
	      -> NPDA x y z -> [[x]] -> Either String String
negativ_liste cut a xss = case take 3 $
    do xs <- xss
       let ks = akzeptierend cut a xs
       guard $ not $ null ks -- d. h. flschlicherweise akzeptiert
       return xs
  of []  -> Right $ "jedes Wort aus der Negativ-Liste wurden nicht akzeptiert"
     xss -> Left  $  render $ fsep
		  $ [ text "diese Wrter der Negativ-Liste wurden doch akzeptiert:"		    , toDoc xss 
		    , fsep $ map (vorrechnen a) xss 
		    ] 
		





