module NPDATest

( Config (..), Mod (..)
, testNPDA
)

where

-- $Log: NPDATest.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.5  2002/01/16 18:08:13  mrahn
-- - Serie 6 fr Kompilation zurechtgebaut
--
-- Revision 1.4  2002/01/14 23:11:14  autotool
-- anpassungen fr serie 6
--
-- Revision 1.3  2002/01/14 01:10:24  autotool
-- pda benutzt language, aufgaben-prototyp
--
-- Revision 1.2  2002/01/13 23:03:33  autotool
-- kellerautomaten: nutze toDoc, akzeptanzmodus sichtbar
--

import NPDA
import DPDA
import Konfiguration

import Vorganger
import Akzeptieren

import Auswertung
import Vorrechnen
import Right
import Monad (guard)
import ToDoc
import Size

data Config = Config 
     { tiefe :: Int
     , det   :: Bool -- True: mu det. sein, False: egal	
     , modus :: Mod
     }
     deriving (Eq, Ord, Show)
     
data Mod = Egal | Keller | Zust 
     deriving (Eq, Ord, Show)

testNPDA
    :: (Ord x, Ord y, Ord z
       , Show x, Show y, Show z
       , ToDoc x, ToDoc y, ToDoc z
       , ToDoc [x], ToDoc [y], ToDoc [z]
       , ToDoc (Maybe x)
    ) 
    => Config
    -> [[x]] -> [[x]]
    -> NPDA x y z 
    -> IO String

testNPDA conf pos neg a = do
    putStrLn $ "Ihr Kellerautomat ist"
    putStrLn $ render $ toDoc a  

    let msg = "OK # Size: " ++ show (size a)

    muss ( check a ) $  
     ( if det conf then muss ( ist_deterministisch a ) else id ) 
     $ ( case modus conf of
	 Egal -> id
	 Keller -> muss ( case ( akzeptiert a ) of 
		Leerer_Keller -> Right ""
		_	      -> Left "Der Automat soll aber durch leeren Keller akzeptieren."
			)
	 Zust ->  muss ( case ( akzeptiert a ) of 
		Zustand _ -> Right ""
		_	-> Left "Der Automat soll aber durch Endzustnde akzeptieren."
			)
       )
     $ do

      putStrLn $ unlines 
	       [ ""
	       , "bei allen folgenden Rechnungen bercksichtige ich"
	       , "nur die ersten " ++ show (tiefe conf) ++ " (durch Breitensuche)"
	       , "erreichbaren Konfigurationen,"
	       , "und auch davon nur die, bei denen das Kellerwort"
	       , "nicht lnger als 2 * (Lnge der noch zu lesenden Eingabe) + 3 ist"
	       , ""
	       ]

      putStrLn $ "ich starte den Automaten auf einigen Wrtern aus L\n"
      let (offen, geheim) = splitAt 2 pos
      vorrechnens a $ offen
      putStrLn $ "\nweitere Eingaben: " ++ render (toDoc  geheim) 

      muss (positiv_liste (tiefe conf) a pos) $ do

        putStrLn $ "ich starte den Automaten auf einigen Wrtern nicht in L\n"
        let (offen, geheim) = splitAt 2 neg
        vorrechnens a $ offen
        putStrLn $ "\nweitere Eingaben: " ++ render (toDoc geheim)

	muss (negativ_liste (tiefe conf) a neg) $

	   right_with msg


