module NPDA_Check_Lang

( check_lang
, Config (..), Mod (..)
)

where

-- $Log: NPDA_Check_Lang.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.3  2002/01/14 23:11:14  autotool
-- anpassungen fr serie 6
--
-- Revision 1.2  2002/01/14 08:10:00  autotool
-- length 20
--
-- Revision 1.1  2002/01/14 01:10:24  autotool
-- pda benutzt language, aufgaben-prototyp
--
-- Revision 1.2  2002/01/13 23:03:33  autotool
-- kellerautomaten: nutze toDoc, akzeptanzmodus sichtbar
--

import NPDA
import NPDATest
import Language
import Edit

import Monad (guard)
import List (nub, partition)
import ToDoc

check_lang
    :: (Ord y, Ord z
       , Show y, Show z
       , ToDoc y, ToDoc z
       , ToDoc [y], ToDoc [z]
    ) 
    => Config
    -> Language
    -> NPDA Char y z 
    -> IO String

check_lang conf l a = do
    putStrLn $ unlines 
	     [ "Ihr Kellerautomat soll die Sprache " ++ abbreviation l ++ " akzeptieren."
	     ]

    ws <- samples l 20 5 -- TODO : sollte auch noch in config

    let large = maximum [ length w | w <- ws ]
    ms <- mapM edits $ ws ++ ws
    let mutants = filter ( \ w -> length w <= large ) ms
    let (yeah, noh) = partition ( contains l ) $ nub $ ws ++ mutants
    
    testNPDA conf yeah noh a

    



