module Vorrechnen

where

-- $Log: Vorrechnen.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.4  2002/01/18 15:09:02  autotool
-- weniger vorrechnen
--
-- Revision 1.3  2002/01/16 18:08:13  mrahn
-- - Serie 6 fr Kompilation zurechtgebaut
--
-- Revision 1.2  2002/01/13 23:03:33  autotool
-- kellerautomaten: nutze toDoc, akzeptanzmodus sichtbar
--

import NPDA
import Konfiguration
import Nachfolger
import Schichten
import ToDoc

vorrechnen :: (Ord x, Ord y, Ord z, 
	   ToDoc x, ToDoc y, ToDoc z
	   ,	 ToDoc [x], ToDoc [y], ToDoc [z]) 
	   => NPDA x y z -> [x] -> Doc
vorrechnen a xs = 
 let cut = 5
 in  fsep $
     [ ( text $ "mit Eingabe " ) <+> toDoc xs 
     , text $ "erreicht der Automat folgende Konfigurationen"
     , text $ "(ich zeige nur die ersten " ++ show cut ++ " schritte)"
     , nest 4 $ fsep $ do
        (i, ks) <- zip [0..] 
		$ map setToList 
		$ take cut
		$ schichten (folgekonfigurationen a   )
		$ start_konfiguration a xs
	return $ text ( "nach " ++ show i ++ " Schritten:" )
	       <+> nest 4 ( fsep $ do k <- ks; return $ toDoc k )
    ]
    
vorrechnens :: (Ord x, Ord y, Ord z, 
	   ToDoc x, ToDoc y, ToDoc z
	   ,	 ToDoc [x], ToDoc [y], ToDoc [z]) 
	   => NPDA x y z -> [[x]] -> IO ()
vorrechnens a = putStrLn . render . fsep . map ( vorrechnen a )


