-- $Header: /home/joe/scratch/challenger/autotool/pump/common/Zerlegung.hs,v 1.1.1.1 2002/05/24 10:46:48 challenger Exp $

module Zerlegung where

-- $Log: Zerlegung.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.2  2001/12/09 16:48:16  autotool
-- pump/standard mehr funktional
--
-- Revision 1.1  2001/12/05 21:13:33  autotool
-- pump/*/* neu
--
-- Revision 1.1  2001/12/04 13:04:10  autotool
-- neu: pump/* lang/*
--

import ToDoc
import Splits
import Monad (guard)

data Zerlegung = Zerlegung
	       { u :: String, v :: String, x :: String, y :: String, z :: String }
     deriving (Read, Eq, Ord)

instance ToDoc Zerlegung where
    toDoc g = 
	 let teile = do
	         (name, wert) <- [ ("u", u g), ("v", v g), ("x", x g), ("y", y g), ("z", z g) ]
		 return $ text name <+> equals <+> toDoc wert
	 in      text "Zerlegung" 
	     <+> braces ( fsep $ punctuate comma $ teile )

instance Show Zerlegung where show = render . toDoc

--------------------------------------------------------------------------

zerlegungen :: String -> Int -> [ Zerlegung ]
-- alle Zerlegungen mit |vxy| <= n, |vy| > 0
zerlegungen w n = do
    ( links, rest ) <- splits w
    ( mitte, rechts ) <- take n $ drop 1 $ splits rest
    ( a, bc ) <- splits mitte
    ( b, c ) <- splits bc
    guard $ not (null (a ++ c))
    return $ Zerlegung { u = links, v = a, x = b, y = c, z = rechts }

--------------------------------------------------------------------------

aufpump :: Zerlegung -> Int -> String
aufpump g i =  u g
	 ++ concat ( replicate i $ v g )
	 ++ x g
	 ++ concat ( replicate i $ y g )
	 ++ z g







