-- $Header: /home/joe/scratch/challenger/autotool/pump/pro/Negativ.hs,v 1.1.1.1 2002/05/24 10:46:48 challenger Exp $

module Negativ

( negativ )

where

-- $Log: Negativ.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.2  2001/12/08 21:34:23  autotool
-- bugfix (w -> w')
--
-- Revision 1.1  2001/12/05 21:13:33  autotool
-- pump/*/* neu
--

import Pump
import Language
import ToDoc
import Auswertung
import Wrong
import Right
import Monad (guard)
import Shortest
import Size

negativ :: Language -> Pump -> IO String
negativ l p @ Nein {} = do
    putStrLn $ unlines
	     [ "Guten Tag. Sie mchten nachweisen,"
	     , "da die Sprache L =  " ++ show l ++ " nicht kontextfrei ist,"
	     , "indem Sie zeigen, da der Durchschnitt von L"
	     , "mit einer geeigneten regulren Sprache R"
	     , "die Pump-Eigenschaft fr kontextfreie Sprachen NICHT erfllt."
	     , ""
	     , "Sie behaupten, zu jeder Zahl n > 0"
	     , "gibt es ein Wort  w  in  R geschnitten L  mit  |w| >= n,"
	     , "so da zu jeder gltigen Zerlegung  w = u v x y z  ein  i  existiert,"
	     , "fr das   u v^i x y^i z  nicht in  R geschnitten L  ist."
	     ]
    let ns = [ 1 .. 10 ]
    let reports = take 3 $ do n <- ns; report l p n
    if null reports
	    then do 
	       putStrLn $ unlines
			[ "OK, Ihr Programm hat in jedem Fall ein passendes i gefunden"
			, "Das beweist, da " ++ show l ++ " nicht kontextfrei ist"
			, "--- oder Sie hatten Glck beim Wrfeln der Testflle."
			]
	       right_with $ "OK # Size: " ++ show (size p)
	    else do 
	       putStrLn $ unlines reports
	       wrong


report l neg @ Nein {} n = 
    let w = wort neg n
	prefix = "Ich whle  n = " ++ show n ++ ", "
	       ++ "Sie whlen  w = " ++ show w ++ "."
    in	map (prefix ++) $ 
	   [ "das  w  ist aber gar nicht in L"  | not (contains l w) ]
	++  [ "das  w  ist aber gar nicht in R"  | not (is_accepted (schnitt neg) w) ]
	++ [ "es gilt aber nicht |w| >= n"            | length w < n       ]
	++ do 
	      z <- zerlegungen w n
	      let i = expo neg n z
	      let w' = aufpump z i
	      let prefix = "\nIch whle " ++ show z ++ ",\n Sie whlen i = " ++ show i
	      map ((prefix ++ "\n") ++ ) $
		     [ "es gilt aber nicht i >= 0\n" | i < 0 ]
		  ++ [ "es ist aber doch  u v^i x y^i z = " ++ show w' ++ " in  L geschnitten R\n"
		         |  contains l w' && is_accepted (schnitt neg) w' ]


	   

       
