-- $Hedaer$

module Positiv

( positiv )

where

-- $Log: Positiv.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.2  2001/12/09 10:47:50  mrahn
-- mehr Testflle
--
-- Revision 1.1  2001/12/05 21:13:33  autotool
-- pump/*/* neu
--

import Pump
import Language
import ToDoc
import Size
import Monad (guard)
import Right
import Wrong
import Auswertung

positiv :: Language -> Pump -> IO String
positiv l p @ Ja {} = do
    putStrLn $ unlines
	     [ "Guten Tag. Sie mchten nachweisen, da die Sprache " ++ show l
	     , "die Pump-Eigenschaft fr kontextfreie Sprachen erfllt."
	     , ""
	     , "Sie behaupten, jedes Wort aus " ++ show l
	     , "mit wenigstens  n = " ++ show (n p) ++ " Buchstaben"
	     , "besitzt eine entsprechende Zerlegung."
	     ]
    muss ( if n p < 1 
	   then Left "Es soll aber n >= 1 sein."
	   else Right "" ) $ do

	 ws <- samples l 200 (n p)
	 putStrLn $ unlines
		  [ "Ich wrfele jetzt einige Wrter der Sprache " ++ show l ++ "," 
		  , "die wenigstens die Lnge  n  haben:"
		  , render $ toDoc ws 
		  , "Jedes davon lasse ich durch Ihre Funktion zerlegen,"
		  , "und teste, ob sich die Zerlegung ab- und aufpumpen lt."
		  ]
	 
	 let reports = take 3 $ do w <- ws; report l p w
	 if null reports
	    then do 
	       putStrLn "OK, ihre Zerlegungen sind korrekt."
	       right_with $ "OK # Size: " ++ show (size p)
	    else do 
	       putStrLn $ unlines reports
	       wrong

report :: Language -> Pump -> String -> [ String ]
report l p w = take 3 $ 
    let g = zerlege p w
	prefix =  unlines
	   [ "aus dem Wort w " ++ show w ++ " konstruieren Sie:"
	   , show g 
	   ]
	uvxyz = u g ++ v g ++ x g ++ y g ++ z g
	vxy = sum $ map length [ v g, x g, y g ]
	vy = sum $ map length [ v g, y g ]
    in	map (prefix ++) $    
	   [ "aber  u v x y z  /=  w." | uvxyz /= w ]
        ++ [ "aber  |v x y| > n."      | vxy > n p  ]
	++ [ "aber  |v y| == 0."       | vy == 0   ]
	++ do
	   i <- [ 0 .. 20 ]
	   let w' = aufpump g i
	   guard $ not $ contains l w'
	   return $ "aber   u v^" ++ show i ++ " x y^" ++ show i ++ " z = " ++ show w'
		  ++ " ist nicht in " ++  show l ++ "\n"
	   

