-- $Header: /home/joe/scratch/challenger/autotool/pump/standard/Negativ.hs,v 1.1.1.1 2002/05/24 10:46:48 challenger Exp $

module Negativ

( negativ )

where

-- $Log: Negativ.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.3  2001/12/13 07:46:02  autotool
-- *** empty log message ***
--
-- Revision 1.2  2001/12/10 00:41:19  autotool
-- aufgabenzettel 5 (pumping)
--
-- Revision 1.1  2001/12/05 21:13:33  autotool
-- pump/*/* neu
--

import Pump
import Language
import ToDoc
import Auswertung
import Wrong
import Right
import Monad (guard)

import Size

negativ :: Language -> Pump -> IO String
negativ l p @ Nein {} = do
    putStrLn $ unlines
	     [ "Guten Tag. Sie mchten nachweisen,"
	     , "da die Sprache L =  " ++ show l
	     , "die Pump-Eigenschaft fr kontextfreie Sprachen NICHT erfllt."
	     , ""
	     , "Sie behaupten, zu jeder Zahl n > 0"
	     , "gibt es ein Wort  w  in L  mit  |w| >= n,"
	     , "so da zu jeder gltigen Zerlegung  w = u v x y z  ein  i  existiert,"
	     , "fr das   u v^i x y^i z  nicht in  L  ist."
	     , ""
	     , "Ihre Liste von Paaren  (n, w)  ist:"
	     , render $ toDoc $ wort p
	     ]

    let reports = take 1 $ do 
		n <- [ 1, 2, 4, 8, 10 ]
		report l p n
    if null reports
	    then do 
	       putStrLn $ unlines
			[ "OK, Ihre Liste ist korrekt."
			, "Das beweist, da " ++ show l ++ " nicht kontextfrei ist"
			, "--- oder Sie hatten Glck beim Wrfeln der Testflle."
			]
	       right_with $ "OK # Size: " ++ show (size p)
	    else do 
	       putStrLn $ unlines reports
	       wrong


report l neg @ Nein {} n = 
    let pre1 = "Ich whle  n = " ++ show n
	mw @ ~ (Just w) = lookupFM (wort neg) n
	pre2 = "Sie whlen  w = " ++ show mw
    in	map ( unlines [ pre1, pre2 ] ++ ) $ 
           [ "Sie haben fr dieses  n  gar kein  w  angegeben."
		 | mw == Nothing ]
	++ [ "w  ist aber gar nicht in L"  
		 | not (contains l w) ]
	++ [ "es gilt aber nicht |w| >= n"            
		 | length w < n       ]
	++ do 
	      z <- zerlegungen w n
	      guard $ null $ expos l n z
	      return $ unlines
		     [ "Ich whle " ++ show z 
		     , "Dafr finden Sie kein  i  mit  u v^i x y^i z  nicht in  L."
		     ]

expos l n z = do
     i <- [ 0 .. 20 ] -- ARBITRARY
     let w' = aufpump z i
     guard $ not $ contains l w'
     return i



	   

       
