-- $Hedaer$

module Positiv

( positiv )

where

-- $Log: Positiv.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.8  2001/12/12 08:24:38  autotool
-- fixes
--
-- Revision 1.7  2001/12/12 08:23:30  autotool
-- auch lngere wrter wrfeln
--
-- Revision 1.6  2001/12/12 08:15:19  autotool
-- sort samples (um fixierte zu verstecken)
--
-- Revision 1.5  2001/12/11 16:39:52  mrahn
-- matrikelnummer als seed fr pseudozufall
--
-- Revision 1.4  2001/12/10 00:41:19  autotool
-- aufgabenzettel 5 (pumping)
--
-- Revision 1.3  2001/12/09 16:48:16  autotool
-- pump/standard mehr funktional
--
-- Revision 1.2  2001/12/08 00:24:49  mrahn
-- - Update INSTALL/TODO
-- - Anpassung PUMP an Prekompilierung inkl. makefile, typo
--
-- Revision 1.1  2001/12/05 21:13:33  autotool
-- pump/*/* neu
--

import Pump
import Language
import ToDoc
import Size
import Monad (guard)
import Right
import Wrong
import Auswertung
import Seed
import Set
import List (sort, nub)

positiv :: Int -> Language -> Pump -> IO String
positiv mat l p @ Ja {} = do
	
    -- eigentlich sollte die Initialisierung des Zufallsgnerators
    -- abhngig von der Matrikelnummer erfolgen!
    -- seed 314159
    seed mat   

    putStrLn $ unlines
	     [ "Guten Tag. Sie mchten nachweisen, da die Sprache " ++ show l
	     , "die Pump-Eigenschaft fr kontextfreie Sprachen erfllt."
	     , ""
	     , "Sie behaupten, JEDES Wort aus " ++ show l
	     , "mit wenigstens  n = " ++ show (n p) ++ " Buchstaben"
	     , "besitzt eine entsprechende Zerlegung."
	     ]
    muss ( if n p < 1 
	   then Left "Es soll aber n >= 1 sein."
	   else Right "" ) $ do

	 ws1 <- samples l 3 (n p)
	 ws2 <- samples l 2 (n p + 3)
	 ws3 <- samples l 2 (n p * cardinality (alphabet l))
	 let ws = sort $ nub $ ws1 ++ ws2 ++ ws3

	 putStrLn $ unlines
		  [ "Ich prfe jetzt, ob die von Ihnen angegebenen Zerlegungen fr die Wrter"
		  , render $ toDoc ws
		  , "tatschlich die geforderten Eigenschaften besitzen."
		  ]
	 
	 let reports = take 1 $ do 
		     w <- ws
		     report l p w
	 if null reports
	      then do 
		   putStrLn "OK, ihre Zerlegungen sind korrekt."
		   right_with $ "OK # Size: " ++ show (size p)
	      else do 
		   putStrLn $ unlines reports
		   wrong

report :: Language -> Pump -> String -> [ String ]
report l p w = take 1 $ 
    let 
	pre1 = "Ich whle  w = " ++ show w 
	z @ ~ (Just g) = lookupFM (zerlege p) w
	pre2 = "Sie whlen " ++ show z
	vxy = sum $ map length [ v g, x g, y g ]
	vy  = sum $ map length [ v g,      y g ]
    in	map (unlines [ pre1 , pre2 ] ++ ) $    
	   [ "Sie haben gar keine Zerlegung fr  w  angegeben."
	         | z == Nothing ]
        ++ [ "aber das ist gar keine Zerlegung von  w."
	         | aufpump g 1 /= w ]
        ++ [ "aber  |v x y| > n."      
                 | vxy > n p  ]
	++ [ "aber  |v y| == 0."       
                 | vy == 0   ]
	++ do
	   i <- [ 0 .. 20 ]
	   let w' = aufpump g i
	   guard $ not $ contains l w'
	   return $ "aber   u v^" ++ show i ++ " x y^" ++ show i ++ " z = " ++ show w'
		  ++ " ist nicht in " ++  show l 
	   

