-- $Header: /home/joe/scratch/challenger/autotool/pump/standard/Pump.hs,v 1.1.1.1 2002/05/24 10:46:48 challenger Exp $

module Pump

( Pump (..)
, module Zerlegung 
, module FiniteMap
)

where

-- $Log: Pump.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.3  2001/12/09 16:48:16  autotool
-- pump/standard mehr funktional
--
-- Revision 1.2  2001/12/08 00:24:49  mrahn
-- - Update INSTALL/TODO
-- - Anpassung PUMP an Prekompilierung inkl. makefile, typo
--
-- Revision 1.1  2001/12/05 21:13:33  autotool
-- pump/*/* neu
--

import Zerlegung
import Size
import ToDoc

import FiniteMap
import ReadFM

data Pump = Nein
	     { wort :: FiniteMap Int String }
	  | Ja
	     { n :: Int
	     , zerlege :: FiniteMap String Zerlegung 
	     }
     deriving (Read,Show)

-- instance Show Pump where show = render . toDoc

instance Size Pump where
    size p @ Nein {} = sum [ length $ w | (n,w) <- fmToList $ wort p ]
    size p @ Ja   {} = n p

instance ToDoc Pump where 
    toDoc ( p @ Nein {} ) = 
	  text "Nein" <+> braces ( fsep $ punctuate comma
	       [ text "wort" <+> equals <+> toDoc ( wort p )
	       ] )
    toDoc ( p @ Ja   {} ) = 
	  text "Ja" <+> braces ( fsep $ punctuate comma
	       [ text "n" <+> equals <+> toDoc (n p)
	       , text "zerlege" <+> equals <+> toDoc (zerlege p)
	       ] )


	   

       




