-- $Header: /home/joe/scratch/challenger/autotool/rewrite/ONEpro.hs,v 1.1.1.1 2002/05/24 10:46:48 challenger Exp $

module ONEpro

( Package (..)
, Pump (..)
, build
, bewerte
)

-- $Log: ONEpro.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.1  2001/12/10 00:41:19  autotool
-- aufgabenzettel 5 (pumping)
--

where

import RL
import Pump
import Pump_Eval
import Auswertung

import ToDoc
import List (nub)
import Monad (guard)

data Package = Package
	     { regel :: RS
	     , start :: String
	     , pump  :: Pump
	     }
     
instance ToDoc Package where
    toDoc p = text "Package" <+> braces ( fsep $ punctuate comma
	  [ text "regel" <+> equals <+> toDoc ( regel p )
	  , text "start" <+> equals <+> toDoc ( start p )
	  , text "pump " <+> equals <+> toDoc ( pump  p )
	  ] )

instance Show Package where show = render . toDoc

-----------------------------------------------------------------

bewerte student = do
    let l = rl (regel student) (start student)
    putStrLn $ unlines
	     [ "Guten Tag."
	     , "Sie behaupten, die Sprache " ++ show l ++ " ist nicht kontextfrei."
	     ]
    muss ( case pump  student of
	   Ja {} -> Left "Dann mssen Sie die Pump-Eigenschaft widerlegen (und nicht besttigen)."
	   Nein {} -> Right "" ) $

        muss ( und [ expandiert        (regel student)
		   , kontrahiert_nicht (regel student)
		   ] ) $ 

	pump_eval l (pump student) 	    
    
-----------------------------------------------------------------

term = unlines
     [ ""
     , "Damit terminiert das System,"
     , "und die erzeugte Sprache ist deswegen endlich,"
     , "also trivialerweise kontextfrei."
     ]

expandiert :: RS -> Either String  String
expandiert (lhs, rhs) =
    case length lhs < length rhs of
        True -> Right $ "Dieses System expandiert."
	False -> Left $ "Dieses System expandiert nicht." ++ term

kontrahiert_nicht :: RS -> Either String String
kontrahiert_nicht (lhs, rhs) = 
    case do x <- nub lhs
	    let cl = length $ filter (== x) rhs
	    let cr = length $ filter (== x) rhs
	    guard $ cl > cr
	    return x
    of [] -> Right "Dieses System kontrahiert keinen Buchstaben."
       x : _ -> Left $ unlines
	   [ "Der Buchstabe " ++ show x
	   , "kommt rechts weniger oft als links vor."
	   ]
	   ++ term

-----------------------------------------------------------------




