module RL where

import Language
import Schichten

import List (nub)
import Set
import Splits
import Monad (guard)


type RS = (String, String)

next :: RS -> String -> Set String
next (lhs, rhs) xs = mkSet $ do
    (links, x) <- splits xs
    let (mitte, rechts) = splitAt (length lhs) x
    guard $ mitte == lhs
    return $ links ++ rhs ++ rechts

nachfolger :: RS -> String -> [ String ]
nachfolger rs start = do
    ws <- schichten (next rs) start
    setToList ws

ist_nachfolger :: RS -> String -> String -> Bool
-- nur sinnvoll, wenn R^-1 (schnell) terminiert
ist_nachfolger (lhs, rhs) start w = 
    start `elem` nachfolger (rhs, lhs) w

rl :: RS -> String -> Language
rl rs @ (lhs, rhs) start = Language 
   { abbreviation = "R^*(" ++ start ++ ") fr  R = " ++ lhs ++ "->" ++ rhs
   , alphabet = mkSet $ lhs ++ rhs ++ start
   , contains = ist_nachfolger rs start
   , sample = \ c n -> return 
	    $ take c 
	    $ dropWhile (\ w -> length w < n) 
	    $ nachfolger rs start
   }




