module Bartel where

import Monad (guard)
import Right
import Auswertung
import Set

bartel :: Integer -> Integer -> [ Set Integer ]
bartel l n = do
    diff <- [ 1 .. n ]
    start <- [ 1 .. n ]
    let end = start + (l - 1) * diff
    guard $ end <= n
    return $ mkSet [ start, start + diff .. end ]

check :: Integer -> Integer -> [ Integer ] -> IO String
check l n stud = do

    let studs = mkSet stud
    let nostuds = mkSet [ 1 .. n ] `minusSet` studs

    putStrLn $ unlines
	     [ "Ich prfe, ob Ihre Belegung"
	     , "eine gewisse Formel mit " ++ show n ++ " Variablen erfllt."
	     , ""
	     , "Sie belegen mit Wahr   die Variablen " ++ show studs
	     , "        und mit Falsch die Variablen " ++ show nostuds
	     , ""
	     ]

    let xss = bartel l n
    
    let nopos = do
          xs <- xss
	  guard $ isEmptySet $ intersectSet xs studs
	  return $ xs

    let noneg = do
          xs <- xss
	  guard $ isEmptySet $ intersectSet xs nostuds
	  return $ xs

    mu ( if not (null nopos)
	then Left $ "Diese Klauseln mit positiven Literalen sind nicht erfllt:\n " ++ show nopos
	else Right $ "Alle Klauseln mit positiven Literalen sind erfllt." ) $ do

    mu ( if not (null noneg)
	then Left $ "Diese Klauseln mit negativen Literalen sind nicht erfllt:\n " ++ show noneg
	else Right $ "Alle Klauseln mit negativen Literalen sind erfllt." ) $ do

    right



    

