-- $Header: /home/joe/scratch/challenger/autotool/serial/Manager.hs,v 1.1.1.1 2002/05/24 10:46:48 challenger Exp $

module Main where -- Queue-Manager

import Config
import Ticket

import Char
import Set
import Concurrent
import Posix
import Directory
import Socket
import System
import IO


----------------------------------------------------------------------

main = do
     Posix.installHandler Posix.sigPIPE Posix.Ignore Nothing
     queue <- newChan :: IO (Chan Id)
     tickets <- newEmptyMVar 

     -- istjemand in kritischer Region?
     critical <- newMVar () -- falls empty, dann ja, falls voll, dann nein
     
     starter queue tickets

     forkIO $ enqueue_listener queue tickets
     forkIO $ dequeue_listener tickets critical

     worker queue tickets critical

----------------------------------------------------------------------

starter queue tickets = do

    putStrLn $ "# starter begins."
    files <- getDirectoryContents queuedir
    ids <- sequence $ do 
        (id, ".arg") <- map (span isAlphaNum) files
	return $ do
	    putStrLn $ "starter enqueues item " ++ show id
	    writeChan queue id
	    return id
    putMVar tickets $ mkSet ids    
    putStrLn $ "# starter ends."

----------------------------------------------------------------------

names id =      
     let common = queuedir ++ id
     in ( common ++ ".arg", common ++ ".stdin" )

----------------------------------------------------------------------

enqueue_listener queue tickets = do
    en <- listenOn $ enqueueport
    en_listener en queue tickets

en_listener sock queue tickets = do

     putStrLn $ "# en_listener waiting at socket."
     (h, rhost, rport) <- accept sock
     putStrLn $ "# en_listener got socket connection."
     cs <- hGetContents h
     putStrLn $ "# en_listener got socket contents:"
     putStrLn $ cs

     hClose h -- ?

     let top : rest = lines cs
     id <- next tickets "entry"
     let n @ ( argfile, stdinfile ) = names id

     writeFile  argfile top
     writeFile  stdinfile (unlines rest)
     putStrLn $ "# en_listener wrote files " ++ show n

     writeChan queue id

     en_listener sock queue tickets

----------------------------------------------------------------------

dequeue_listener tickets critical = do
    en <- listenOn $ dequeueport
    de_listener en tickets critical

de_listener sock tickets critical = do

     putStrLn $ "# de_listener waiting at socket."
     (h, rhost, rport) <- accept sock
     putStrLn $ "# de_listener got socket connection."
     cs <- hGetContents h
     putStrLn $ "# de_listener got socket contents."
     let id : rest = lines cs
     putStrLn $ "# de_listener got item " ++ show id

     hClose h -- ?

     let ( argfile, stdinfile ) = names id
     exe $ unwords [ "rm", "-f", stdinfile, argfile ]
     Ticket.release tickets id    

     putStrLn $ "# de_listener wants to leave critical region " 
     putMVar critical ()
     putStrLn $ "# de_listener DID leave critical region " 

     de_listener sock tickets critical

----------------------------------------------------------------------

worker queue tickets critical = do

    putStrLn $ "# worker wants to enter critical region."
    foo <- takeMVar critical
    putStrLn $ "# worker DID enter critical region."

    putStrLn $ "# worker waiting at queue."
    id <- readChan queue
    putStrLn $ "# worker got item " ++ show id

    let ( argfile, stdinfile ) = names id

    argsR <- readFile argfile
    let args = read argsR
    exe $ unwords [ "(", "cat", stdinfile, "|" , automain, unwords args 
		  , ";", "Dequeue", id, ")", "&" 
		  ]    

    worker queue tickets critical


exe cmd = do
    putStrLn $ "# going to execute " ++ show cmd 
    system $ cmd
    putStrLn $ "# done with " ++ show cmd




