module Ticket where

import Concurrent
import Set
import Monad (guard)

type Id = String

next :: MVar ( Set Id ) -> String -> IO Id
next tickets pre = do
    ids <- takeMVar tickets
    let id = head $ do 
	  i <- [1 ..]
	  let id = pre ++ show i
	  guard $ not (id `elementOf` ids)
	  return id
    putMVar tickets ( union ids (unitSet id) )	
    putStrLn $ "# creating a new item " ++ show id
    return id

release :: MVar ( Set Id ) -> Id -> IO ()
release tickets id = do
    ids <- takeMVar tickets
    putMVar tickets ( ids `minusSet` unitSet id )
    putStrLn $ "# releasing item " ++ show id





