module UNI12 where

import Fun
import Random

import AL
import Code

import Vorrechnen
import Typeof

import Report
import Right
import Wrong

rechne = durchrechnen 1000 al

check_code :: Code -> (Integer, Integer) -> Report ()
check_code c (x, y) = do
    p  <- rechne (paar  c) [x, y]
    px <- rechne (links c) [p]
    py <- rechne (rechts c) [p]
    if (px, py) /= (x, y)
       then fail $ "Kodierung/Dekodierung von " ++ show (x,y)
		 ++ " ergibt " ++ show (px, py)
       else return ()

check_codes :: Code -> [(Integer, Integer)] -> Report ()
check_codes c xys = do
    check_arity "paar" 2 (paar c)
    check_arity "links" 1 (links c)
    check_arity "rechts" 1 (rechts c)
    sequence_ $ do xy <- xys; return $ check_code c xy


bewerte student = do
    putStrLn $ unlines	
	     [ "Ich bin der automatische Korrektor fr die Aufgabe UNI11."
	     , "Zu finden waren eine primitiv-rekursive Definitionen"
	     , "zur Kodierungs/Dekodierung von Zahlenpaaren."
	     , ""
	     , "Ihre Definition lautet " ++ show student
	     , ""
	     , "Ich prfe erst die Typkorrektheit und rechne dann einige Werte aus."
	     , ""
	     ]

    random <- sequence $ take 5 $ repeat $ do
        x <- randomRIO (0, 10)
        y <- randomRIO (0, 10)
	return (x, y)
    
    case check_codes student random of
	 OK _     -> right
	 Fail msg -> do putStrLn $ msg
			wrong

