module UNI2 where

import Fun
import Random

import AL
import Code

import Vorrechnen
import Table
import Typeof

import Report
import Right
import Wrong

rechne = durchrechnen 1000 al

check_code :: Code -> (Integer, Integer) -> Report ()
check_code c (x, y) = do
    p  <- rechne (paar  c) [x, y]
    px <- rechne (links c) [p]
    py <- rechne (rechts c) [p]
    if (px, py) /= (x, y)
       then fail $ "Kodierung von " ++ show (x,y)
		 ++ " ergibt " ++ show p
		 ++ ", Dekodierung davon ergibt " ++ show (px, py)
       else return ()

check_arities_show_tables :: Code -> Report String
check_arities_show_tables c = do
    check_arity "paar" 2 (paar c)
    let tp = [ "paar" , tafel 2 12 1000 al (paar c), "" ]
    check_arity "links" 1 (links c)
    let tl = [ "links" , tafel 1 12 1000 al (links c), "" ]
    check_arity "rechts" 1 (rechts c)
    let tr = [ "rechts" , tafel 1 12 1000 al (rechts c), "" ]
    return $  unlines
	   $ [ "Die Typen der Funktionen sind korrekt."
	     , "Die Wertetabellen sind:"
	     , ""
	     ]
	     ++ tp ++ tl ++ tr

check_codes :: Code -> [(Integer, Integer)] -> Report ()
check_codes c xys = do
    sequence_ $ do xy <- xys; return $ check_code c xy

bewerte student = do
    putStrLn $ unlines	
	     [ "Ich bin der automatische Korrektor fr die Aufgabe UNI2."
	     , "Zu finden waren primitiv-rekursive Definitionen"
	     , "zur Kodierungs/Dekodierung von Zahlenpaaren."
	     , ""
	     , "Ihre Definition lautet " ++ show student
	     , ""
	     , "Ich prfe erst die Typkorrektheit und rechne dann einige Werte aus."
	     , ""
	     ]

    random <- sequence $ take 5 $ repeat $ do
        x <- randomRIO (0, 10)
        y <- randomRIO (0, 10)
	return (x, y)

    case check_arities_show_tables student of
	 Fail msg -> do putStrLn msg
			wrong 
	 OK msg   -> do

    putStrLn msg

    case check_codes student random of
	 OK _     -> right
	 Fail msg -> do putStrLn $ msg
			wrong

