module LoesungTM44 where

import Turing

data Z = Q0 | Q1 | Q2 | Q3 | Q5
     deriving (Eq, Ord, Show)

student :: Turing Char Z
student = Turing 
        { eingabealphabet = mkSet "A"
        , leerzeichen     = '#'
        , arbeitsalphabet = mkSet "#AB"
        , zustandsmenge  = mkSet [ Q0, Q1, Q2, Q3, Q5 ]
        , tafel = t
        , startzustand   = Q0
        , endzustandsmenge = mkSet [ Q3 ]
        }


t = listToFM
      [ ( ('#', Q0), mkSet [ ( '#', Q3, O ) ] )

      , ( ('A', Q0), mkSet [ ( '#', Q5, R ) ] )
      , ( ('#', Q5), mkSet [ ( '#', Q3, O ) ] )

      , ( ('A', Q5), mkSet [ ( '#', Q1, R ) ] )

      , ( ('A', Q1), mkSet [ ( 'A', Q1, R ) ] )
      , ( ('#', Q1), mkSet [ ( '#', Q2, L ) ] )

      , ( ('A', Q2), mkSet [ ( 'B', Q1, R ) ] )
      , ( ('B', Q2), mkSet [ ( 'A', Q2, L ) ] )
      , ( ('#', Q2), mkSet [ ( '#', Q3, O ) ] )
      ]


