-- $Id: Maschine.hs,v 1.1.1.1 2002/05/24 10:47:02 challenger Exp $

module Alternate.Maschine where

import Baum
import Alternate.Status

import ToDoc

-- m = Maschine, 
-- e = Eingabe,
-- k = Konfiguration


class Start m e k | m -> e  where
      start :: m -> e -> k

class Next m k | m -> k where
      next :: m -> k -> [ k ]

class ( Start m e k, Hat_Status k, Next m k, Ord k
      , ToDoc m, ToDoc k, ToDoc [e])		
      => Maschine m e k  


rechnung :: ( Start m e k, Next m k, Hat_Status k )
           => m -> e -> Baum (k, Bool)
rechnung m e = erfolgreich $ baum m e


baum :: ( Start m e k, Next m k )
     => m -> e -> Baum k
baum m e = baum' (start m e)
    where  baum' k = Baum { wurzel = k
			  , kinder = map baum' $ next m k
			  }


erfolgreich :: Hat_Status k => Baum k -> Baum (k, Bool)
-- annotiert, ob teilbaum erfolgreich
erfolgreich b =
    let bs = map erfolgreich $ kinder b
	es = map (snd . wurzel) bs
	op = case status (wurzel b) of
		  Existenziell -> or; Universell -> and
    in	Baum { wurzel = (wurzel b, op es) 
	     , kinder = bs 
	     }


prune :: Baum (k, Bool) -> Baum k
-- lscht alle Teilbume, deren Wurzeln mit False markiert sind
-- (lscht aber die Wurzel selbst nicht)
prune b =
    let (w, e) = wurzel b
    in	Baum { wurzel = w
	     , kinder = map prune 
		      $ filter ( snd . wurzel ) $ kinder b
	     }


