-- $Id: Wahrheit.hs,v 1.1.1.1 2002/05/24 10:47:02 challenger Exp $

module Alternate.Wahrheit where

import ToDoc

data Wahrheit = Nein | Vielleicht | Ja
     deriving (Eq, Ord, Show, Read)

instance ToDoc Wahrheit where toDoc = text . show

bool :: Wahrheit -> Bool
bool Nein = False
bool Vielleicht = error "bool Vielleicht"
bool Ja = True


-- diese funktionen sind hoffentlich etwas lazy

findmin :: [ Wahrheit ] -> Wahrheit
findmin xs = go Ja xs
   where go w [] = w
	 go Nein _ = Nein
	 go w (x : xs) = go (min w x) xs

findmax :: [ Wahrheit ] -> Wahrheit
findmax xs = go Nein xs
   where go w [] = w
	 go Ja _ = Ja
	 go w (x : xs) = go (max w x) xs

