module Baum.BFS 

( bfs, bfss )

where

import Baum.Type

import Set
import List (nubBy)
import Monad (guard)

bfs  :: Ord a => Baum a -> [ a ]
-- List der Knoten in Breitensuche, ohne Duplikate
bfs b = concat $ bfss b

bfss :: Ord a => Baum a -> [[ a ]]
-- Liste der Schichten der Knoten in Breitensuche, ohne Duplikate
bfss b = breit emptySet [b]

breit :: Ord a => Set a -> [Baum a] -> [[ a ]]
breit schon [] = []
breit schon noch =
    let neu = nubBy ( \ x y -> wurzel x == wurzel y )
	    $ do n <- noch
		 guard $ not $ elementOf (wurzel n) schon
		 return n
	tops = map wurzel neu
    in	tops : breit ( union schon $ mkSet tops ) 
		     ( concat $ map kinder neu )


