module Baum.Display where

import Baum.Type
import Baum.Ops

import ToDoc

kette :: Baum a -> ( [a], Baum a )
-- verfolgt Kinder, solange sie die einzigen sind
kette b = case kinder b of
      [ k ] -> let ( xs, rest ) = kette k
	       in  ( wurzel b : xs, rest )
      _	    -> ( [], b )

display :: ToDoc a => Baum a -> Doc
display b = 
    let ( xs , z ) = kette b
	pfeil = text "->"
	txs = fsep $ punctuate pfeil $ map toDoc xs
	tz  = toDoc (wurzel z) 
	    <+> brackets ( vcat $ map display $ kinder z )
    in	txs <+> pfeil <+> tz

    