module Bild.Diag where

import Bild
import Language

import Random
import Set
import ToDoc

diag :: Language Char (Bild Char)
diag = Language 
     { name = "DIAG"
     , alphabet     = mkSet "01"
     , definition = text "{ b : b in SQUARES und ( b_xy = 1 )<=>(x = y) }"
     , contains = \ b -> ( breit b == hoch b ) && and ( do
		  x <- [ 0 .. breit b - 1 ]
		  y <- [ 0 .. hoch  b - 1 ]
		  return $ b `at` (x,y) == if x == y then '1' else '0' )
     , sample = \ c n -> return $ do
           m <- [ n .. n + c ]
	   let b = uniform '0' (m, m)
	   return $ tos b [ ((k, k), '1') | k <- [ 0 .. m - 1 ] ]
     , anti_sample = anti diag
     }

