module Bild.Equal where

import Bild
import Language

import Random
import Set
import ToDoc

firstlast :: Language Char (Bild Char)
firstlast = Language 
     { name = "FIRSTLAST"
     , alphabet     = mkSet "01"
     , definition = text "{ b : erste und letzte Spalte stimmen berein }"
     , contains = \ b -> and ( do
		  y <- [ 0 .. hoch  b - 1 ]
		  return $ b `at` (0,y) == b `at` (breit b - 1, y) )
     , sample = \ c n -> sequence $ replicate c $ do
           x <- randomRIO (1,n)
	   f <- randomRIO (False, True)
	   let (b,h) = if f then (x, n) else (n, x)
	   lr <- irgendein (1,h) "01"
	   if b <= 1 
	      then return lr
	      else do m <- irgendein (b - 2, h) "01"
		      return $ the $ neben lr $ the $ neben m lr
     , anti_sample = anti firstlast
     }

firstsome :: Language Char (Bild Char)
firstsome = Language 
     { name = "FIRSTSOME"
     , alphabet     = mkSet "01"
     , definition = text "{ b : erste und irgendeine andere Spalte sind gleich }"
     , contains = \ b -> or $ do 
           x <- [ 2 .. breit b - 1 ]
	   return $ and $ do
		  y <- [ 0 .. hoch  b - 1 ]
		  return $ b `at` (0,y) == b `at` (x, y)
     , sample = \ c n -> sequence $ replicate c $ do
           x <- randomRIO (1,n)
	   f <- randomRIO (False, True)
	   let (b,h) = if f then (x, n) else (n, x)
	   lr <- irgendein (1,h) "01"
	   if b <= 1 
	      then return lr
	      else do let d = b - 2
		      d1 <- randomRIO (0, d)
		      m1 <- irgendein (d1, h) "01"
		      m2 <- irgendein (d - d1, h) "01"
		      return $ the $ neben lr 
			     $ the $  neben m1
			     $ the $ neben lr m2

     , anti_sample = anti firstsome
     }




