module Fourway.Type

-- zweidimensionaler alternierender automat

-- akzeptierender zustand = universeller zustand ohne nachfolger
-- ablehnender zustand    = existentieller zustand ohne nachfolger

where

import Fourway.Bewegung
import Bild

import ToDoc
import Size
import Set
import FiniteMap

data Fourway s z =
     Fourway { alphabet :: Set s
	 , randzeichen :: s
	 , existenziell :: Set z
	 , universell :: Set z
	 , startet :: z
	 , tafel :: FiniteMap ( z, s ) ( Set (z, Bewegung) )
	 }

class (Ord s, Ord z, Show s, Show z, ToDoc s, ToDoc z 
      , ToDoc [Bild s], ToDoc [s], ToDoc [z]) 
      => FourwayC s z 
      -- ohne methoden, soll nur die constraints aufsammeln

instance FourwayC Char Integer


instance Size (Fourway s z) where size = size . tafel

instance FourwayC s z => ToDoc (Fourway s z) where
   toDoc m = text "Fourway" <+> braces ( fsep $ punctuate comma
       [ text "alphabet" <+> equals <+> toDoc (alphabet m)
       , text "randzeichen" <+> equals <+> toDoc (randzeichen m)
       , text "existenziell" <+> equals <+> toDoc (existenziell m)
       , text "universell" <+> equals <+> toDoc (universell m)
       , text "startet" <+> equals <+> toDoc (startet m)
       , text "tafel" <+> equals <+> toDoc (tafel m)
       ] )




