module Konfig.Type

where

import Bild.Type ( Bild )
import Bild.Position
import qualified Alternate.Status as S

import ToDoc


data Konfig s z = 
     Konfig { pos  :: Position
	    , zustand :: z
	    , status :: S.Status 
	    , bild :: Bild s
	    }
   deriving (Eq, Ord)

instance ( ToDoc s, ToDoc z ) => ToDoc (Konfig s z) where
    toDoc k = text "Konfig" <+> braces ( fsep $ punctuate comma
	    [ text "pos" <+> equals <+> toDoc (pos k)
	    , text "zustand" <+> equals <+> toDoc (zustand k)
	    , text "status" <+> equals <+> toDoc (status k)
	    ] )


