module Language.Comp

where

import Prelude hiding ( compare )

import qualified Size

import Language.Type
import Language.Portrait
import Language.Sample
import Language.Edit
import Language.Object
import Language.Alpha
import Language.Complement

import ToDoc
import FiniteMap

import Right -- old-style autotool
import Wrong

class  ( ToDoc [a], ToDoc [o]
	   , Show a, Show o, Show [o], Edit o
	   , Object a o ) => Foo a o

{-
comp :: Foo a o
	=> Int -> Int -> Language a o -> Language a o -> IO String
-}

comp number size lang student = do

    putStrLn "Guten Tag. Gegeben war die Sprache:"
    port lang
    putStrLn "Sie haben eingesandt:"
    port student

    let s = Size.size student
    let msg = "OK # Size: " ++ show s

    fails <- diff number size lang student
    if null fails
       then right_with msg
       else wrong


{-
symdiff :: Foo a o 
	=> Int -> Int -> Language a o -> Language a o -> String
	-> IO String
-}
symdiff number size l1 l2 = do
    d12 <- diff number size l1 l2
    d21 <- diff number size l2 l1
    return $ d12 ++ d21

{-
diff :: Foo a o 
	=> Int -> Int -> Language a o -> Language a o 
	-> IO [o]
-}
diff number size from to = do
    putStrLn $ unlines
	     [ "Ich vergleiche die Sprache " ++ show from
	     , "mit der Sprache " ++ show to   
	     ]
    os <- samples from number size
    ps <- mapM edits os
    qs <- mapM ( \ o -> someIO (Size.size o) (alpha o) )  os
    rs <- samples (complement from) number size
    let reports = do 
	    ob <- rs ++ os ++ ps ++ qs 
	    return ( (contains from ob, contains to ob), [ob] )
    let fm = addListToFM_C (++) emptyFM reports
    let [ nohnoh,  nohyeah, yeahnoh, yeahyeah ] = do 
            x <- [ False .. True ]; y <- [ False .. True ]
	    return $ lookupWithDefaultFM fm [] (x, y)
    putStrLn $ unlines
	     [ "diese Objekte sind in " ++ show from ++ " und in " ++ show to
	     , show yeahyeah
	     , "diese Objekte sind weder in " ++ show from ++ " noch in " ++ show to
	     , show nohnoh
	     , "diese Objekte sind in " ++ show from ++ ", aber nicht in " ++ show to
	     , show yeahnoh
	     , "diese Objekte sind nicht in " ++ show from ++ ", aber in " ++ show to
	     , show nohyeah
	     ]
    return $ yeahnoh ++ nohyeah




	
    
