module Language.Portrait where

import Language.Type
import Language.Sample
import Language.Complement
import Language.Object

import ToDoc

portrait :: (ToDoc [a], ToDoc [o], Object a o) 
	 => Language a o -> IO Doc
portrait l = do
    os <- samples l 10 3 
    ps <- samples (complement l) 10 3 
    let doc = text "Language" <+> braces ( vcat $ punctuate comma
	    [ text "name" <+> equals <+> toDoc ( name l )
	    , text "alphabet" <+> equals <+> toDoc ( alphabet l )
	    , text "definition" <+> equals <+>  ( definition l )
	    , text "samples" <+> equals <+> toDoc os
	    , text "anti_samples" <+> equals <+> toDoc ps
	    ] )
    return doc

port :: (ToDoc [a], ToDoc [o], Object a o)
     => Language a o -> IO ()
port l = do
    doc <- portrait l
    putStrLn $ render doc
