-- $Id: Sample.hs,v 1.1.1.1 2002/05/24 10:47:03 challenger Exp $

module Language.Sample

where


import Language.Type
import Language.Object

import Monad (guard)
import Random



random_samples :: Object a o
	       => Language a o -> Int -> Int -> IO [ o ]
-- wrfeln und testen
-- nur sinnvoll, wenn sprache gengend dicht ist
random_samples l c n = do
    ws <- sequence $ replicate c $ someIO n $ alphabet l
    return $ filter (contains l) ws

       
samples :: Language a o -> Int -> Int -> IO [ o ]
-- wrfelt genau (!) c Objekte der Sprache l, mit size >= n,
-- dabei von jeder festen lnge hchstens sqrt c viele
-- das klappt nur, wenn die sprache unendlich ist
samples l c n | c > 0 && n < 20 = do
    let m = truncate $ sqrt $ fromIntegral c    
    here <- sample l m n 
    let d = 1 -- d <- randomRIO (1, 3)
    there <- samples l (c - length here) (n + d)
    return $ here ++ there
samples l c n = return []
    
