-- $Id: Type.hs,v 1.1.1.1 2002/05/24 10:47:03 challenger Exp $

module Language.Type

where

import Language.Object
import Language.Alpha

import ToDoc
import Set
import Size

-- Beschreibt Menge von Objekten :: o ber Alphabet :: a

type Sampler o = Int -> Int -> IO [o]

data Language a o = Language
	      { name :: String
	      , definition   :: Doc
	      , _size :: Int
	      , alphabet     :: Set a

	      -- testet Mitgliedschaft in Sprache
	      , contains     :: o -> Bool

	      -- sample  c n
	      -- wrfelt maximal c Wrter der Sprache
	      -- mit Size == n
	      , sample       :: Sampler o

	      -- und ein paar Wrter aus dem Komplement
	      , anti_sample       :: Sampler o

	      }



instance Alpha a (Language a o) where alpha = alphabet

instance Size ( Language a o ) where size = _size

instance Show ( Language a o ) where
    show = name

instance (Object a (Language a o), ToDoc [a]) 
	 => ToDoc ( Language a o ) where
    toDoc l = text "Language" <+> braces ( vcat $ punctuate comma
	    [ text "name" <+> equals <+> toDoc ( name l )
	    , text "alphabet" <+> equals <+> toDoc ( alphabet l )
	    , text "definition" <+> equals <+>     ( definition l )
	    , text "size" <+> equals <+> toDoc ( size l )
	    ] )




    

