module Local.Cover where

import Local.Type
import Bild

import FiniteMap
import Set
import Monad (guard)

subpic :: Position -> Position -> Bild s -> Bild s
subpic (x,y) (b,h) p = takeH b $ dropH x 
		     $ takeV h $ dropV y
		     $ p

missing :: Ord s => Local s -> Bild s -> [ (Position, Bild s) ]
-- teilbilder, die nicht berdeckt wurden
missing loc p = do
    ((b, h), ts) <- fmToList $ addListToFM_C union emptyFM
			     $ do t <- setToList $ tiles loc
				  return (dims t, unitSet t)
    let q = rahmen (rand loc) p
    x <- [ 0 .. breit q - b ]
    y <- [ 0 .. hoch  q - h ]
    let t = subpic (x,y) (b,h) q
    guard $ not $ elementOf t ts
    return ((x, y), t)
    
