module Local.Type where

import Bild.Type
import Language.Object
import Language.Alpha

import Set

import ToDoc
import Size

data Local a =
     Local { tiles :: Set ( Bild a )
	   , rand  :: a
	   }

instance Size (Local a) where size = size . tiles


instance ( ToDoc a, ToDoc [ Bild a ] )
	 => ToDoc (Local a) where
    toDoc t = text "Local" <+> braces ( fsep $ punctuate comma
	  [ text "tiles" <+> equals <+> toDoc ( tiles t )
	  , text "rand" <+> equals <+> toDoc ( rand t )
	  ] )


instance ( ToDoc a, ToDoc [ Bild a ] )
	 => Show (Local a) where show = render . toDoc

instance Ord s => Alpha s (Local s) where
    alpha = unionManySets . map alpha . setToList . tiles
