module Machine.Check where


import Machine.Type
import Machine.Wahrheit
import Machine.Run
import Machine.World

import qualified Size

import Baum
import Language
import Language.Object

import ToDoc
import Set
import List (partition)

import Right -- old-style autotool
import Wrong

{-
check_language :: ( Edit obj , ToDoc obj, ToDoc [ obj], ToDoc [alpha]
		  , Object alpha obj 
		  , Initial obj state, Ask state quest, Act state act 
		  )
	       => Int -> Int -> Int
	       -> Language alpha obj ->  Program quest act
	       -> IO String
-}
check_language size number depth lang prog = do
    let s = Size.size prog
    let msg = "OK # Size: " ++ show s

    os <- samples lang number size
    ps <- mapM edits os
    rs <- samples (complement lang) number size

    let reports = map ( check_object depth lang prog ) $ os ++ ps ++ rs
    let eins (a,b,c) = a; zwei (a,b,c) = b; drei (a,b,c) = c
    let yeah = filter ( (== Ja) . zwei ) reports
    let noh  = filter ( (== Nein) . zwei ) reports
    let may  = filter ( (== Vielleicht) . zwei ) reports
    putStrLn $ unlines
	     [ "Guten Tag. Gesucht war ein Automat fr"]
    port lang
    putStrLn $ unlines
	     [ "\nSie haben eingesandt:"
	     , render $ toDoc prog
	     , "\nich generiere " ++ show number ++ " Objekte"
	     ++ " ab der Gre " ++ show size
	     , "und simuliere Rechnungen von bis zu " ++ show depth ++ " Schritten."
	     
	     , "\n(Ich zeige im folgenden nur die jeweils 5 ersten Objekte)"
	     , "\nIhr Automat behandelt korrekt:"
	     , render $ toDoc $ take 5 $ map eins yeah
	     , "\nIhr Automat behandelt inkorrekt:"
	     , render $ toDoc $ take 5 $ map eins noh
	     , "\nIhr Automat rechnet zu lange fr:"
	     , render $ toDoc $ take 5 $ map eins may
	     ]
    putStrLn $ unlines
	     [ "Hier sehen Sie einige Berechnungen."
	     , ""
	     ]
    let focus = take 2 yeah ++ take 2 noh ++ take 2 may
    mapM_ (putStrLn . render . info) focus

    if null noh 
       then right_with msg 
       else wrong


info :: ToDoc obj 
     => ( obj, Wahrheit, Doc) -> Doc
info (a, b, c) = 
       vcat [ text "Eingabe" <+> equals <+> toDoc a
	    , text "Trace" <+> equals <+> c
	    ]

---------------------------------------------------------------------------

{-
check_object :: ( Initial obj state
		, Ask state quest
		, Act state act )
	     => Int -> Language alpha obj -> Program quest act -> obj
	     -> (obj, Wahrheit, Doc)
-}
check_object depth lang prog b =
    let v = contains lang b
	( w, t ) = run prog depth b 
	r = case w of
		 Vielleicht -> w
		 _ -> if bool w == v then Ja else Nein
    in	( b, r, t )
		





	
    
