module RX.Dove where

import List (nub)

merge :: Eq a => [a] -> [a] -> [a]
merge xs [] = xs; merge [] ys = ys
merge (x : xs) ys = x : filter (/= x) ( merge ys xs )


biased_merge ::  [a] -> [a] -> [a]
-- immer weniger vom ersten argument
biased_merge = bm 1 

bm :: Int -> [a] -> [a] -> [a]
bm n [] ys = ys; bm n xs [] = xs
bm n (x : xs) ys = 
    let (pre, post) = splitAt n ys
    in	x : pre ++ bm (n+1) xs post

dovetail :: Eq a => [[a]] -> [a]
dovetail [] = []
dovetail (xs : xss) = biased_merge xs (dovetail xss)


