-- $Head$

module ExpShow where

import ExpType

instance Show Exp where 
    showsPrec p (Ref cs) = showString " " . showString cs
    showsPrec p (Letter c) = showString [c]

    showsPrec p (Union l r) = 
	klammer 2 p $ showsPrec 2 l . showString " + " . showsPrec 2 r
    showsPrec p (Difference l r) = 
	klammer 2 p $ showsPrec 2 l . showString " - " . showsPrec 2 r
    showsPrec p (SymDiff l r) = 
	klammer 2 p $ showsPrec 2 l . showString " <> " . showsPrec 2 r

    showsPrec p (Intersection l r) = 
	klammer 3 p $ showsPrec 3 l . showString " & " . showsPrec 3 r
    showsPrec p (Shuffle l r) = 
	klammer 4 p $ showsPrec 4 l . showString " $ " . showsPrec 4 r
    showsPrec p (Dot l r) = 
 	klammer 5 p $ showsPrec 5 l . showsPrec 5 r	

    showsPrec p (Star x) = 
	( klammer 6 p $ showsPrec 6 x ) . showString "^* "
    showsPrec p (Plus x) = 
	( klammer 6 p $ showsPrec 6 x ) . showString "^+ "
    showsPrec p (Power e x) = 
	( klammer 6 p $ showsPrec 6 x ) . showString "^" . shows e
	     . showString " "

klammer p0 p s = if p > p0 then  showString " (" . s . showString ") " else s 



