-- $Header: /home/joe/scratch/challenger/autotool/twodim/RX/Inter.hs,v 1.1.1.1 2002/05/24 10:47:03 challenger Exp $

module Inter

( inter
, std, std_sigma
, E
)

where

import NFA
import Exp
import qualified Ops
import qualified Minus
import qualified Shuffle

import qualified Env as E

import Normalize
import Minimize

import qualified Basic

---------------------------------------------------------------------------

type E = E.Env (NFA Int)

std :: E
std =  E.make 
	  [ ("Eps", Basic.epsilon)
	  , ("Empty", Basic.empty)
	  ]

std_sigma :: String -> E
std_sigma alpha = E.add std ( "Sigma", Basic.sigma alpha )


norm :: Ord a => NFA a -> NFA Int
norm = minimize . normalize


inter :: E -> Exp -> NFA Int
inter e (Ref v)    = case E.look e v of
      Just x -> x
      Nothing -> error $ "Name " ++ show v ++ " nicht gebunden"

inter e (Letter c) = norm $ Basic.letter c

inter e (Dot          l r) = norm $ Ops.dot          (inter e l) (inter e r)
inter e (Union        l r) = norm $ Ops.union        (inter e l) (inter e r)
inter e (Shuffle      l r) = norm $ Shuffle.shuffle  (inter e l) (inter e r)
inter e (Difference   l r) = norm $ Minus.minus      (inter e l) (inter e r)
inter e (SymDiff      l r) = norm $ Minus.symdiff    (inter e l) (inter e r)
inter e (Intersection l r) = norm $ Ops.intersection (inter e l) (inter e r)

inter e (Star x)   = norm $ Ops.star    (inter e x)
inter e (Plus x)   = norm $ Ops.plus    (inter e x)
inter e (Power p x)= norm $ Ops.power p (inter e x) 

---------------------------------------------------------------------------

-- instance Read (NFA Int) where 
-- uses instance Read Exp
--   readsPrec p inp = do
--	     (x, rest) <- reads inp
--	     return (inter std x, rest)
	




