module RX.Match 

( match )

where

import RX.Type
import Bild

match :: RX -> Bild Char -> Bool
match (Letter c) p =
    1 == breit p && 1 == hoch p && c == p `at` (0,0)

match (Union l r) p = match l p || match r p
match (Intersection l r) p = match l p && match r p
match (Difference l r) p =  match l p && not (match r p)

match (Dot d l r) p = helper d 0 l r p

match e @ (Star d x) p 
    | ist_leer p = True
    | otherwise = match (Plus d x) p

match (Plus Both x) p = match (Plus Horizontal (Plus Vertical x)) p

match e @ (Plus d x) p = match x p || helper d 1 x e p 


helper d start l r p = or $ do
    k <- [ start .. dim d p ]
    let pl = takeD d k p
	pr = dropD d k p
    return $ match l pl && match r pr

