-- $Header: /home/joe/scratch/challenger/autotool/twodim/RX/Printer.hs,v 1.1.1.1 2002/05/24 10:47:03 challenger Exp $

module RX.Printer where

import RX.Klammer
import RX.Type

import Bild.Type (Direction (..))

instance Klammer RX where 
    klammer (Ref cs)   = const $ text cs
    klammer (Letter c) = const $ text [c]

    klammer (Union l r) = binary 2 "+" l r
    klammer (Difference l r) = binary' 3 "-" l r
    klammer (Intersection l r) = binary 5 "&" l r

    klammer (Dot Horizontal l r) = binary0 6 l r
    klammer (Dot Vertical l r) = binary 6 ".-" l r

    klammer (Star Horizontal x) = postfix 7 "^*|" x
    klammer (Star Vertical x) = postfix 7 "^*-" x
    klammer (Star Both x) = postfix 7 "^**" x

    klammer (Plus Horizontal x) = postfix 7 "^+|" x
    klammer (Plus Vertical x) = postfix 7 "^+-" x


instance ToDoc RX where
    toDoc x = klammer x 0

instance Show RX where
    show = render . toDoc


instance ToDoc Statement where
    toDoc (Print x) = text "print" <+> toDoc x
    toDoc (Let lhs rhs) = text "let" <+> fsep [ toDoc lhs, equals, toDoc rhs ]

instance ToDoc [ Statement ] where
    toDoc xs = vcat [ toDoc x <> semi | x <- xs ]




