-- $Header: /home/joe/scratch/challenger/autotool/twodim/RX/Syntax.hs,v 1.1.1.1 2002/05/24 10:47:03 challenger Exp $

module Syntax where

import Exp (Exp (..))
import Report
import Set 
import Size
import Auswertung

subtrees :: Exp -> [ Exp ]
subtrees x = x : case x of
 
    Ref c -> []
    Letter c -> []

    Dot l r -> subtrees l ++ subtrees r
    Union l r  -> subtrees l ++ subtrees r
    Intersection l r -> subtrees l ++ subtrees r
    Difference l r -> subtrees l ++ subtrees r
    SymDiff l r -> subtrees l ++ subtrees r
    Shuffle l r -> subtrees l ++ subtrees r

    Star x -> subtrees x
    Plus x -> subtrees x
    Power i x -> subtrees x

instance Size Exp where size = length . subtrees

constructor :: Exp -> String
constructor x = case x of

    Ref n -> "Ref"
    Letter c -> "Letter"

    Dot l r -> "Dot"
    Union l r  -> "Union"
    Intersection l r -> "Intersection"
    Difference l r -> "Difference"
    SymDiff l r -> "SymDiff"
    Shuffle l r -> "Shuffle"

    Star x -> "Star"
    Plus x -> "Plus"
    Power i x -> "Power"


constructors :: Exp  -> Set String 
constructors = 
    mkSet . map constructor . subtrees 


einfach :: Exp -> IO String -> IO String
einfach x = muss
	  $ let cs = constructors x
		ss = mkSet [ "Ref", "Letter"
			   , "Dot", "Union", "Star"
			   ]
		ds = minusSet cs ss
	    in	if isEmptySet ds
		then Right "ist einfacher regulrer Ausdruck"
		else Left $ unlines
			  [ "diese Operatoren sind in einfachen regulren Ausdrcken nicht zugelassen:"
			  , show (setToList ds)
			  ]

