-- $Header: /home/joe/scratch/challenger/autotool/twodim/RX/Type.hs,v 1.1.1.1 2002/05/24 10:47:03 challenger Exp $

module RX.Type where

import Bild.Type (Direction)
import Language.Alpha

import Size

import Set

data RX
	= Ref String  -- reference to value in environment

	| Letter Char

	| Union RX RX
	| Intersection RX RX
	| Difference RX RX

	| Dot Direction RX RX

	| Star Direction RX
	| Plus Direction RX
	

    deriving Eq

data Statement 
     = Print  RX
     | Let String RX

instance Size RX where
    size x = case x of

	Letter c -> 1
	
	Union l r -> 1 + size l + size r
	Intersection l r -> size l + size r
	Difference l r -> size l + size r
	
	Dot d l r -> size l + size r
	
	Star d x -> size x
	Plus d x -> size x


instance Alpha Char RX where
   alpha x = case x of

	Letter c -> unitSet c
	
	Union l r -> alpha l `union` alpha r
	Intersection l r -> alpha l `union` alpha r
	Difference l r -> alpha l `union` alpha r
	
	Dot d l r -> alpha l `union` alpha r
	
	Star d x -> alpha x
	Plus d x -> alpha x

	



