module Wort.Type where
-- eindimensionale Bewegungen

import Language.Object
import Language.Address

import ToDoc
import Set
import Random
import Monad ( guard )

data LR = L | R
     deriving (Eq, Ord, Show, Read)
instance ToDoc LR where toDoc = text . show

instance Directed Int LR where
    move i L = i - 1
    move i R = i + 1

instance Ord a => Object a [a] where
    someIO s alpha = do
        let xs = setToList alpha
        sequence $ replicate s $ do
	    k <- randomRIO (0, length xs - 1)
	    return $ xs !! k

instance Address a [a] Int where
    top xs = 0
    peek xs i = do
        guard $ 0 <= i && i < length xs
	return $ xs !! i



