-- $Header: /home/joe/scratch/challenger/autotool/util/Edit.hs,v 1.1.1.1 2002/05/24 10:46:48 challenger Exp $

module Edit where

-- vollfhrt einige String-Edit-Operationen,
-- damit die Grammatik-Programme Testwrter haben,
-- die "in der Nhe" der Zielsprache liegen

-- $Log: Edit.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:48  challenger
-- start
--
-- Revision 1.1  2002/01/14 01:10:24  autotool
-- pda benutzt language, aufgaben-prototyp
--
-- Revision 1.2  2001/11/21 16:44:06  autotool
-- bessere version von Chomsky.hs
-- bessere testflle fr CF4
--
-- Revision 1.1  2001/11/18 23:57:05  autotool
-- neu: chomsky-form, greibach-form, CYK-parser und hilfsprogramme
--

import Random
import Monad

cut :: Int -> Int -> [a] -> [a]
cut from to w = 
    let (pre, post) = splitAt from w
    in	pre ++ drop (to - from) post

mirror :: Int -> Int -> [a] -> [a]
mirror from to w = 
    let (pre, post) = splitAt from w
	(here, there) = splitAt (to - from) post
    in	pre ++ reverse here ++ there

insert_slice :: Int -> Int -> Int -> [a] -> [a]
insert_slice from to at w =
    let slice = take (to - from) $ drop from w
	(here, there) = splitAt at w
    in	here ++ slice ++ there

max_edit = 3 :: Int
    
some_cut :: [a] -> IO [a]
some_cut w = if length w < max_edit then return w else do
    d <- randomRIO ( 1 , max_edit )
    i <- randomRIO ( 0 , length w - d )
    return  $ cut i (i+d) w
    
some_mirror :: [a] -> IO [a]
some_mirror w = if length w < max_edit then return w else do
    d <- randomRIO ( 1 , max_edit )
    i <- randomRIO ( 0 , length w - d )
    return  $ mirror i (i+d) w

some_insert_slice :: [a] -> IO [a]
some_insert_slice w = if length w < max_edit then return w else do
    d <- randomRIO ( 1 , max_edit )
    i <- randomRIO ( 0 , length w - d )
    k <- randomRIO (0    , length w - 1)
    return $ insert_slice i (i+d) k w

edit :: [a] -> IO [a]
edit w = do
    f <- randomRIO (False, True)
    if f then some_cut w else some_insert_slice w

edits :: [a] -> IO [a]
edits w = do
    k <- randomRIO (1, max_edit)
    foldM ( \ u _ -> edit u ) w $ replicate k ()
    
    

