module State where

-- kombinierte writer- und zustands-monade

data State s c a = State ( c -> (s -> s, c, a) )

instance Functor (State s c) where
    fmap f (State t) = State $ \  c -> 
 	let ( s', c',   x ) = t c 
	in  ( s', c', f x )

instance Monad (State s c) where
    return x = State $ \  c  -> ( id , c, x )
    State t >>= f = State $ \  c  ->
	let ( s', c', x) = t c
	    State t' = f x
	    ( s'', c'', x'') =  t'  c'
	in  ( s' . s'', c'', x'' )

run :: State s c a -> ( s -> s , c , a )
run (State t) = t undefined 

put :: c -> State s c ()
put c = State $ \ _ -> ( id, c, () )

get :: State s c c
get = State $ \  c  -> ( id, c, c )  

write :: (s -> s) -> State s c ()
write f = State $ \ c -> ( f, c, () )
