--- $Header: /home/joe/scratch/challenger/autotool/ws01/aufgaben/CF4.hs,v 1.3 2002/05/28 07:10:05 joe Exp $

module CF4 where

-- $Log: CF4.hs,v $
-- Revision 1.3  2002/05/28 07:10:05  joe
-- mat
--
-- Revision 1.2  2002/05/24 11:32:31  challenger
-- bewerte: neuer typ
--
-- Revision 1.1.1.1  2002/05/24 10:46:49  challenger
-- start
--
-- Revision 1.10  2002/01/15 08:23:15  autotool
-- aufrumen
--
-- Revision 1.9  2001/12/01 15:39:03  autotool
-- noch bessere tests
--
-- Revision 1.8  2001/12/01 15:28:31  autotool
-- weniger test
--
-- Revision 1.7  2001/12/01 14:47:33  autotool
-- prekompilierte grader
--
-- Revision 1.6  2001/11/29 13:41:20  autotool
-- CF_advanced: besserer parser, hrtere tests
--
-- Revision 1.5  2001/11/29 09:59:01  autotool
-- gaps
--
-- Revision 1.4  2001/11/26 13:56:18  autotool
-- stark vereinfachte Anzeige von Ableitungen
--
-- Revision 1.3  2001/11/23 08:26:32  autotool
-- decode lehnt wrter ab, die mit 0 beginnen
--
-- Revision 1.2  2001/11/21 16:44:06  autotool
-- bessere version von Chomsky.hs
-- bessere testflle fr CF4
--
-- Revision 1.1  2001/11/18 23:58:38  autotool
-- neu: aufgaben zu kontextfreien grammatiken
--

import Grammatik
import Typen
import Simple_Zeige
import Wort
import Edit
import Random
import CF_Check
import Monad (guard)

bin :: Int -> [ Int ]
bin n = reverse $ bins n
    where bins 0 = []
	  bins n = let (a,b) = divMod n 2 in  b : bins a

nib :: [ Int ] -> Int
nib = foldl ( \ n d -> n * 2 + d ) 0 


encode :: [ Int ] -> String
encode xs = do
    x <- xs
    let bs = do b <- bin x; show b
    bs ++ "#"

nearly :: Int -> IO String
nearly s = do
    let xs = [1 .. s]
    ys <- edit xs
    return $ encode ys

count :: Int -> String
count n = encode [ 1 .. n ]

decode :: String -> [ Int ]
decode "" = []
decode cs | head cs == '1' = 
    let (pre, post) = span (`elem` "01") cs
	dec c = fromEnum c - fromEnum '0'
    in	case post of
	'#' : rest -> ( nib $ map dec pre ) : decode rest
	_ -> [ 0 ]
decode sonst = [ -1 ]

ok :: String -> Bool
ok w = 
    let xs = decode w
    in	xs == [ 1 .. length xs ]

--------------------------------------------------------------------------

sigma = "01#"

sonst :: IO [ String ]
sonst = do
    x <- randomRIO (1, 3)
    y <- randomRIO (x+1, x+3)
    let mid = encode [ x .. y ]
    let vorns = [ c : mid | c <- sigma ]
    let hints = [ init mid ]

    z <- randomRIO (y+1, y+3)
    let late = encode [ y+1 .. z ]
    let mitts = [ mid ++ "#" ++ late, mid ++ "0" ++ late ]
    let ends = [ encode [x .. y-1] ++ encode [y+1 .. z] ]
    
    return $ vorns ++ hints ++ mitts ++ ends

---------------------------------------------------------------------

gap :: Int -> Int -> Int -> String
gap x skip more =  encode [ 1 .. x ] 
		++ encode [ x + skip + 1 .. x + skip + more ]

gaps = do
     x    <- [  1, 2, 3, 4, 7, 10, 15 ]
     skip <- [ -4, -1, 2, 4, 6 ]
     more <- [ 2 ]
     guard $ x + skip >= 0
     guard $ odd skip <= ( x < 7 )
     let g = gap x skip more
     -- guard $ length g <= 50
     return g
       
--------------------------------------------------------------------------

failures = do
   randoms <- mapM (someIO sigma) [ 5 .. 10 ]
   s <- sonst
   return $ randoms ++ s ++ gaps


candidates = do
   let klein = alle sigma 3
   let correct = map count [ 1 .. 10 ]
   fs <- failures
   return $ klein ++ correct ++ fs



bewerte :: String ->  Grammatik -> IO String
bewerte mat g = do
    putStrLn $ unlines
	     [ "Ich bin das Korrekturprogramm fr die Aufgabe CF4."
	     ]
    muss ( typ2 g ) $ do
 
       zeige (Just 10) g

       cs <- candidates

       -- cf_check_nomutate (not . ok) cs g
       cf_check (not . ok) cs g





