-- $Header: /home/joe/scratch/challenger/autotool/ws01/aufgaben/Lukas.hs,v 1.1.1.1 2002/05/24 10:46:49 challenger Exp $

module Lukas where

-- Sprache von Lukasiewicz

-- $Log: Lukas.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:49  challenger
-- start
--
-- Revision 1.1  2001/11/18 23:58:38  autotool
-- neu: aufgaben zu kontextfreien grammatiken
--

import Set
import List ( mapAccumL )
import Random

import Wort
import Grammatik
import CF_Check

diffs :: String -> [ Int ]
diffs w = snd $ mapAccumL (\ x c -> 
      let y = case c of 'a' -> 1; 'b' -> -1 
      in  (x+y, x+y) ) 0 w

lukas :: String -> Bool
lukas [] = False
lukas w = 
    let ds = diffs w
    in	and [ d >= 0 | d <- init ds ]
	&& last ds < 0

balanced :: Int -> IO String
balanced n | n > 0 = do
    a <- randomRIO (0,n-1)
    let b = n-1-a
    u <- balanced a
    v <- balanced b
    return $ "a" ++ u ++ "b" ++ v
balanced _ = return ""

good :: Int -> IO String
good n = do
    w <- balanced n
    return $ w ++ "b"







