-- $Header: /home/joe/scratch/challenger/autotool/ws01/aufgaben/NFAcommon.hs,v 1.1.1.1 2002/05/24 10:46:49 challenger Exp $

module NFAcommon where

-- $Log: NFAcommon.hs,v $
-- Revision 1.1.1.1  2002/05/24 10:46:49  challenger
-- start
--
-- Revision 1.10  2001/12/03 09:19:18  mrahn
-- - work aufrumen
-- - umlaute aus fa/Properties raus
--
-- Revision 1.9  2001/12/01 11:50:27  mrahn
-- vorkompilierte Korrekturprogramme
--
-- Revision 1.8  2001/11/19 08:04:22  autotool
-- fehler in Minus.complement behoben
--
-- Revision 1.7  2001/11/18 14:14:36  mrahn
-- - minimierter Automat fr Vergleich wg. Speed
--
-- Revision 1.6  2001/11/16 11:44:03  autotool
-- fr NFAcommon: benutze neue Funktion Minus.minus_det
-- zum vergleichen, spare das deterministisch-und-minimieren.
--

import Exp
import qualified Env
import Syntax
import Sanity
import Inter
import Set
import Normalize
import Trim
import Vergleiche
import Size
import Auswertung
import ToDoc
import NFA
import Properties
import Restrict

common :: (ToDoc a, ToDoc [a], Ord a) => String -> Exp -> NFA a -> IO String
common msg goal aut = do
    putStrLn $ "Ich bin das Korrekturprogramm fr Aufgabe " ++ msg

    putStrLn $ "\nSie haben diesen endlichen Automaten S eingesandt:"
    print aut

    let alpha = "ab"
    muss ( restrict_size 20 aut )
	 $ muss ( restrict_states aut )
	 $ muss ( restrict_alpha (mkSet alpha) aut )
         $ muss ( deterministisch aut ) 
         $ muss ( vollstaendig (mkSet alpha) aut ) 
         $ do
	     let ok = "OK # Size: " ++ show (size aut)
	     let std = std_sigma alpha
	     vergleiche_det ok ( inter std goal ) 
		               ( minimize $ normalize aut  )
