module SetUtil where

import Set
import FiniteMap

lookupset :: Ord a => FiniteMap a (Set b) -> a -> Set b
lookupset fm = lookupWithDefaultFM fm emptySet

smap :: (Ord a, Ord b) => (a -> b) -> (Set a -> Set b)
smap f = mkSet . map f . setToList

sconcat :: Ord v => Set (Set v) -> Set v
sconcat = unionManySets . setToList

subset :: Ord v => Set v -> Set v -> Bool
subset xs ys = isEmptySet (xs `minusSet` ys)

fmmap :: Ord b => 
      (a -> b) -> (c -> d) -> (FiniteMap a c -> FiniteMap b d)
fmmap f g fm = 
      -- addListToFM_C (error "fmmap merges keys") emptyFM
      listToFM -- allows merging
      [ (f key, g val) | (key, val) <- fmToList fm ]

pick :: Ord b => Set b -> (b, Set b)
-- select on element
-- TODO: make implementation more efficient
-- by exploiting the tree structure (remove root, merge sons)
pick s = let x : xs = setToList s
	 in  (x, mkSet xs)

